

/*
 * $Id: Gedaechtnis.java,v 1.43 2002/07/14 12:00:41 sg Exp $
 *
 */

 /**
  * History der OverviewObjects.
   * Fuehrt Interpolation unbekannter Aufenthaltskoordinaten durch.
   * @author Marcus Schumacher (ms)
   * @author Patrick Gaertner (pg)
   *
   */


   public class Gedaechtnis
 {
	 // Referenzen
	 private Player play;
	 private Weltbild weltb;
	 // Attribute
   /** Array in dem die letzten 4 OverviewObject gespeichert werden */
	 private OverviewObject[] verlauf = new OverviewObject[4];
	 private OverviewObject intplOverview;
   /** speichert die interpolierten Werte*/
	 private XyzObject intplPlayer = new XyzObject();
	 private XyzObject intplEnemy  = new XyzObject();
	 private XyzObject intplBall   = new XyzObject();
   /** Counter wieviele OVs gesetzt wurden */
	 private int no = -1;
   /** wurde das verlaufsArray zum ersten mal durchlaufen */
     private int first = 0;
     /** speichert die letzte HearMessage*/
     private String[] hearMsg = {"0", "0", "12", "XyObject"};
     /** speichert die Arcus Werte in einem Array */
     int[] arccosArray = new int[2001];

	 // Konstruktor

     public Gedaechtnis(Player playIn, Weltbild weltbIn)
	 	{
		 		this.play = playIn;
		 		this.weltb = weltbIn;
 				setArccos();
	 	}
 	 	// get & set Methoden

    /** setzt das neue OverviewObject, welches vom Weltbild geliefert wird in den Verlaufsarray
     * @author pg
     * @param aktOV das aktuelle OverviewObject
     */
    public void setOV (OverviewObject aktOV)
    {
        System.arraycopy(this.verlauf, 0, this.verlauf, 1, 3);
        this.no +=1;
        if (this.no == 4) this.first = 1;
        this.verlauf[0] = aktOV;
    }

    public Player getPlay()
	 	{
    		return this.play;
	 	}
    public Weltbild getWeltb()
	 	{
	 		return this.weltb;
	 	}

 	public void setLastHear(String[] msg)
	{
	  this.hearMsg=msg;
    }

/** Fllt das arccos-Array mit Werten
   *  @author fg
   */
 	private void setArccos()
  {
    double x;
    for (int i=0; i<=2000; i++)
    {
       x = ((double)i / 1000) - 1;
       arccosArray[i] = (int)Math.round(Math.toDegrees(Math.acos(x)));
    }
  }

  /** Schlgt den Arcus-Cosinus in einer Tabelle nach und liefert den zugehrigen Winkel im Gradmass zurck
   *  @author fg
   *  @param x Double zwischen -1 und 1 von dem der arccos ausgerechnet werdne soll.
   *  @return ArcusCosiuns von x oder 4444 wenn x nicht im bereich von -1 bis 1
   */
  private int arccos(double x)
  {
    if (x < -1 || x > 1) return 4444;
    int pos = (int)((x + 1) * 1000);
    return arccosArray[pos];
  }


/** interpoliert die Position eines Teamspielers
 *  @author ms
 * @return intplPlayer die eventuelle Position des Spielers
 */
public XyzObject intplPlayerPos(int pos)
    {
        XyzObject player = new XyzObject();
        /** Erst wenn berhaupt das Gedchtnis mit OVs gefttert wurde, kann auch nachgeschaut werden*/
        if (first == 1)

        {

            float X1 = this.verlauf[0].get1PlayerPos(pos).getX();
            float X2 = 0;
            float Y1 = this.verlauf[0].get1PlayerPos(pos).getY();
            float Y2 = 0;
            float Abstand = 0;
            int zaehler=0;
            for ( int i = 0; i<=1; i++)
                {
                    /** gehe das Array durch bis eine gesehene Position gefunden wurde */
                    if (X1 == 4444)
                    {
                        X1 =this.verlauf[i].get1PlayerPos(pos).getX();
                        Y1 = this.verlauf[i].get1PlayerPos(pos).getY();

                    }
                /** umsetzten der Variablen, damit der Abstand zw. den Punkten bestimmt werden kann    */
                if (X1 != 4444 && zaehler ==0)
                    {
                        X2 = X1;
                        X1 = 4444;
                        Y2 = Y1;
                        Y1 = 4444;
                        zaehler =1;

                    }
                }
            // falls nichts brauchbares gefunden wurde, Pech gehabt
                if ( X1 == 4444)
                    {
                        player.setX(4444);
                        player.setY(4444);
                    }
                /** Errechnen der Position, wo ,der Spieler ungefhr sein knnte*/
                else
                    {

                        Abstand = X2-X1;
                        X2 = X2 + Abstand;
                        Abstand = Y2-Y1;
                        Y2 = Y2 + Abstand ;
                        player.setX((int)X2);
                        player.setY((int)Y2);
                    }
            }
       else
       {
           	player.setX(4444);
            player.setY(4444);
       }
 		return player;
 	}

    /** interpoliert die Position eines Feindspielers
     * @author ms
     * @return intplEnemy die eventuelle Position des geg. Spielers
     * */
    public XyzObject intplEnemyPos(int pos1)
	 	{
        XyzObject enemy = new XyzObject();
        int pos = pos1;
        /** Erst wenn berhaupt das Gedchtnis mit OVs gefttert wurde, kann auch nachgeschaut werden*/
        if (first == 1)

        {
            float X1 = this.verlauf[0].get1EnemyPos(pos).getX();
            float X2 = 0;
            float Y1 = this.verlauf[0].get1EnemyPos(pos).getY();
            float Y2 = 0;
            float Abstand = 0;
            int zaehler=0;
            for ( int i = 0; i<=1; i++)
                {
                    if (X1 == 4444)
                    {
                        /** gehe das Array durch bis eine gesehene Position gefunden wurde */
                        X1 = this.verlauf[i].get1EnemyPos(pos).getX();
                        Y1 = this.verlauf[i].get1EnemyPos(pos).getY();

                    }
                /** umsetzten der Variablen, damit der Abstand zw. den Punkten bestimmt werden kann    */
                if (X1 != 4444 && zaehler ==0)
                    {
                        X2 = X1;
                        X1 = 4444;
                        Y2 = Y1;
                        Y1 = 4444;
                        zaehler =1;

                    }
                }
            // Falls nichts brauchbares gefunden wurde, Pech gehabt
                if ( X1 == 4444)
                    {
                        enemy.setX(4444);
                        enemy.setY(4444);
                    }
              /** Ansonsten bestimmen der ungefhren Position  */
                else
                    {

                        Abstand = X2-X1;
                        X2 = X2 + Abstand;
                        Abstand = Y2-Y1;
                        Y2 = Y2 + Abstand ;
                        enemy.setX((int)X2);
                        enemy.setY((int)Y2);
                    }
            }
        // Fr alle anderen Faelle
       else
       {
           	enemy.setX(4444);
            enemy.setY(4444);
       }

	 		return enemy;
	 	}

    /** interpoliert die Ballposition bzw. schaut in der HearNachricht nach
     * @author ms
     * @return intplBall die eventuelle Ballposition
     *
     */
        public XyzObject intplBallPos()
	 	{
        XyzObject ball = new XyzObject();
        double hear1 =0;
        double hear2 =0;
        // kann erst durchgefhrt werden, wenn berhaupt etwas im Verlauf steht
        if (first == 1)

        {
            // Schaue nach, ob vielleicht jemand die aktuelle Position des Balles gebruellt hat
            if (this.hearMsg[0].equals("ball"))
            {
                hear1 = Double.parseDouble(hearMsg[1]);
                hear2 = Double.parseDouble(hearMsg[2]);
                this.intplBall.setX((int)hear1);
                this.intplBall.setY((int)hear2);
                hearMsg[0] = "alt";
            }
            // Ansonsten denke (versuch es zumindest :-)
            else
            {

            float X1 = this.verlauf[0].getBallPos().getX();
            float X2 = 0;
            float Y1 = this.verlauf[0].getBallPos().getY();
            float Y2 = 0;
            float Abstand = 0;
            int zaehler=0;
            for ( int i = 0; i<=1; i++)
               {
                // suche den ersten brauchbaren Wert
                    if (X1 == 4444)
                    {
                        X1 = this.verlauf[i].getBallPos().getX();
                        Y1 = this.verlauf[i].getBallPos().getY();

                    }
                // umsetzen der Variablen, damit der nchste brauchbare Wert gesucht wird
                if (X1 != 4444 && zaehler ==0)
                    {
                        X2 = X1;
                        X1 = 4444;
                        Y2 = Y1;
                        Y1 = 4444;
                        zaehler =1;

                    }
                }
            // nix gefunden
                if ( X1 == 4444 )
                    {
                        ball.setX(4444);
                        ball.setY(4444);
                    }

                // Ansonsten bestimme die ungefhre Position
                else
                    {
                        Abstand = X2-X1;
                        X2 = X2 + Abstand;
                        Abstand = Y2-Y1;
                        Y2 = Y2 + Abstand ;
                        this.intplBall.setX((int)X2);
                        this.intplBall.setY((int)Y2);
                    }
            }
            }
       else
       {
           	this.intplBall.setX(4444);
            this.intplBall.setY(4444);
       }
        	// interpoliert die Ballposition in/vor (rndzhl) Runden
	 		return this.intplBall;
	 	}



	/** gibt die Ballposition die aktuelle Bewegung und den Bewegungswinkel zurueck
	 * @author pg
	 * @return intplBall Ballposition mit distanz / Winkel
	 * @see moveTo in Klasse Player, selbe winkelberechnung
	 */
	public XyzObject extrapl(XyzObject ball)
	{
        double a = 0;
        double g = 0;
        double dir = 0;
		/** waehlt das letzte OverviewObject aus dem Verlaufarray aus */
        if (first == 0){}
        else
        {
  		    /** Berechnung der Ankathete */
            a = (this.verlauf[0].getBallPos().getX()) - (this.verlauf[1].getBallPos().getX());
	  	    /** Berechnung der Gegenkathete */
		        g = (this.verlauf[0].getBallPos().getY()) - (this.verlauf[1].getBallPos().getY());

   /** die Differenz der X und Y Koordinaten werden uebergeben */
          ball.setA((int)a);
          ball.setB((int)g);

        }
        return ball;
	}
}

/*
  * $Log: Gedaechtnis.java,v $
  * Revision 1.43  2002/07/14 12:00:41  sg
  * alte Version (1.40) ausgecheckt.. "Verbesserungen" von Markus haben leider bewirkt, das die Spieler keine BallPos mehr hren konnten.. Geht jetzt wieder..
  *
  * Revision 1.40  2002/07/08 04:11:57  ms
  * - ArrayDurchlauf verkrzt
  *
  * Revision 1.39  2002/07/08 04:09:02  ms
  * - noch was beim Ball geaendert
  *
  * Revision 1.38  2002/07/08 03:54:06  ms
  * - kleine Aenderungen
  *
  * Revision 1.37  2002/07/08 03:20:27  ms
  * -- Es wird jetzt nicht mehr alzu lange im Gedaechtniss nachgeschaut
  *
  * Revision 1.36  2002/07/08 02:48:59  ms
  * - aufgeraeumt und fertig kommentiert
  *
  * Revision 1.35  2002/07/07 18:32:38  pg
  * neue extrapl, uebergibt nun nur noch die Koordinatendifferenzen
  *
  * Revision 1.34  2002/07/07 18:17:47  ms
  * - Arraydurchlufe in den Methoden entsprechen den vorrigen
  *   Aenderungen angepasst
  *
  * Revision 1.33  2002/07/07 18:01:02  pg
  * kleiner tippfehler...
  *
  * Revision 1.32  2002/07/07 18:00:14  pg
  * neue setOv: aktuelles OverviewObject jetzt immer in verlauf[0]
  *
  * Revision 1.31  2002/07/07 01:15:27  ms
  * - NullPointerException bedingt durch die Weltbild
  *   umstellung entfernt
  *
  * Revision 1.30  2002/07/06 22:42:47  ms
  * - Aufgerumt und kommentiert
  *
  * Revision 1.29  2002/07/06 21:25:31  fg
  * Arccos-Methoden kommentiert
  *
  * Revision 1.28  2002/07/06 21:12:00  fg
  * Klammerfehler
  *
  * Revision 1.27  2002/07/06 21:02:32  fg
  * effizientere arccos Methode eingebaut
  *
  * Revision 1.26  2002/07/06 20:25:46  ms
  * - Gedchtniss arbeitet jetzt wieder einwandfrei
  *
  * Revision 1.25  2002/07/06 17:28:05  ms
  * *** empty log message ***
  *
  * Revision 1.24  2002/07/06 16:19:47  ms
  * -extrapl gendert
  *
  * Revision 1.23  2002/07/06 14:58:14  pg
  * bleoder schriebfehler
  *
  * Revision 1.22  2002/07/06 14:39:02  fg
  * Fehler korrigiert
  *
  * Revision 1.21  2002/07/06 14:28:07  ms
  * *** empty log message ***
  *
  * Revision 1.20  2002/07/06 12:48:52  ms
  * - es wird nicht mehr das komplette OV bergeben, sondern nur noch die wichtigsten Dinge
  *   kommt jetzt nicht mehr zu gleichen referenzen
  *
  * Revision 1.19  2002/07/06 02:51:41  fg
  * *** empty log message ***
  *
  * Revision 1.18  2002/07/06 01:46:35  ms
  * - ArrayException entfernt
  *
  * Revision 1.17  2002/07/06 01:38:33  pg
  * double weg
  *
  * Revision 1.8  2002/07/05 23:47:38  ms
  * - Performance Fresser entfernt
  *
  * Revision 1.7  2002/07/05 23:43:54  pg
  * extrapolation implementiert
  *
  * Revision 1.6  2002/07/05 20:03:52  ms
  * - Durchlauf des Gedchtniss gendert
  *   allerdings leidet die Performance erheblich darunter
  *
  * Revision 1.5  2002/07/05 17:49:30  ms
  * - Kommentare eingefgt, plus ne Kleinigkeit
  *
  * Revision 1.4  2002/07/05 17:16:47  ms
  * - Hear Msg wird fr die BallPos verwendet
  *
  * Revision 1.3  2002/07/03 14:51:11  ms
  * - die Spieler merken sich jetz, die Pos des Balles, der eigenen Mitspieler
  *   und der gegnerischen Spieler (zwar mit nem IQ von 10, aber immerhin)
  *
  * Revision 1.2  2002/07/03 10:19:53  fg
  * *** empty log message ***
  *
  * Revision 1.1.1.1  2002/06/05 10:38:57  pg
  * intital version
  *
  */




