/*
 * $Id: Jamaica.java,v 1.12 2002/07/08 06:42:11 js Exp $
 *
 */

/**
  * Hauptklasse
  * initialisiert die einzelnen Spieler
  * @author Florian Grassl (fg) 
  */

public class Jamaica
{
  // Attribute
  static public Player[] prozess;

  /** Main - Methode
    * Wertet die Kommandozeilenparameter aus und setzt alles in Gang
    * @param TeamName Der Teamname steht als default auf "Jamaica", wird nur bei Angabe von 3 bzw 4 Paramatern angepat
    * @param servName Der Servername steht als default auf "localhost", wird nur bei Angabe von 3 bzw 4 Paramatern angepat
    * @param servPort Der Serverport steht als default auf "6000", wird nur bei Angabe von 3 bzw 4 Paramatern angepat
    * @param Visu Argument ob Visualisierung gestartet werden soll oder nicht
    */
  public static void main (String[] args) throws Exception
  {
    boolean visual=false;                      // Defaultwert der Visualisierung
    String ServName="localhost";              // Defaultwert des Servernamens
    int servPort=6000;                        // Defaultwert des Serverports
    String TeamName="Jamaica";                // Defaultwert des Teamnamens
    
    if (args.length == 3 || args.length== 4)  // Falls 3 od 4 Uebergabewerte, gesetzt sind, wird entspr. angepasst
    {
      TeamName=args[0];
      ServName=args[1];
      
      try
      {
        servPort=Integer.parseInt(args[2]);
      }
      catch(NumberFormatException n)
      {
        System.err.println("Es wurde ein unzulaessiger Serverport angegeben!");
        System.err.println("Bitte folgende Richtlinien beachten:");
        System.err.println();
        usage();
        System.exit(1);
      }

      
      if (args.length == 4)
      {
        visual = true;
      }
    }
    else
    {
      if (args.length!=0)
      {
        System.err.println("Parameterangaben inkorrekt!");
        System.err.println("Bitte folgende Richtlinien beachten:");
        System.err.println();
        usage();
        System.exit(1);
      }
    }
    
    prozess = new Player[11];                               // es wird das Spielerarray erzeugt
    prozess[0] = new Torwart(ServName,servPort,TeamName);   // es wird 1 Torwart erzeugt
    prozess[0].init();                                      // Der Torwart wird initialisiert

    for (int i=2; i<=11; i++)                               // die restlichen 10 Spieler werden erzeugt und und initialisiert
    {
      prozess[i-1] = new Player(i, ServName, servPort, TeamName);
      prozess[i-1].init();
    }
    Thread.sleep(500);                    // Pausierung des Threads um Spielernummerzuweisungen richtig zu erhalten
    for (int i=1; i<=11; i++)
    {
      prozess[i-1].start();               // Starten der 11 Spielerprozesse
    }
    if (visual)                           // Falls Visualisierungsparameter gesetzt, wird die Visualisierung gestartet
    {
      Visualisierung vm = new Visualisierung(prozess);
      Thread vt = new Thread(vm);
      vt.start();
    }
  }
  
  private static void usage()
  {
    System.out.println("Programmaufruf:");
    System.out.println();
    System.out.println("java Jamaica Teamname Servername ServerPort [String]");
    System.out.println();
    System.out.println("Das Programm muss mit keinem, 3 oder optional 4 Parametern gestartet werden!");
    System.out.println("Ohne Paramter werden Defaultwerte verwendet!");
    System.out.println();
    System.out.println("Teamname  : Ist der Name der Mannschaft im Monitor (default: Jamaica)");
    System.out.println("Servername: IP-Adresse oder DNS-Name des Servers (default: localhost)");
    System.out.println("Serverport: Port des Robo-Servers.Positiver Ganzzahlwert (default: 6000)");
    System.out.println("[String]  : Ein Beliebiger String beliebiger Laenge.");
    System.out.println("             Veranlasst den Start der Visualisierung.");
    System.out.println();
  }
  
}

/*
 * $Log: Jamaica.java,v $
 * Revision 1.12  2002/07/08 06:42:11  js
 * Parameter-Bug beseitigt
 *
 * Revision 1.11  2002/07/08 06:02:04  js
 * Fehlerbehandlung mit entsprechenden Textausgaben eingefuegt
 *
 * Revision 1.10  2002/07/07 03:04:31  js
 * JavaDoc und Kommentierung
 *
 * Revision 1.9  2002/07/06 21:29:58  fg
 * - Parameter Aufruf entspricht jetzt Anforderungen
 * - Visualisierung kann mit irgendeinem 4ten Parameter gestartet werden
 *
 * Revision 1.8  2002/07/06 20:01:42  sg
 * weitere Auftstellung eingefhrt
 *
 * Revision 1.7  2002/07/06 17:22:05  sg
 * neue Pass()
 *
 * Revision 1.6  2002/06/25 20:33:36  fg
 * Visualisierung wird automatisch gestartet, wer es nicht mag, einfach Visual=false setzen :)
 *
 * Revision 1.5  2002/06/25 16:31:47  fg
 * Visualisierung kann gestartet werden
 *
 * Revision 1.4  2002/06/07 22:12:20  fg
 * Aufruf der player-Prozesse implementiert
 *
 * Revision 1.3  2002/06/05 14:55:07  ms
 * nur das blablabla entfernt
 *
 * Revision 1.2  2002/06/05 10:43:01  hj
 * ein test vom tutor :-)))
 *
 * Revision 1.1.1.1  2002/06/05 10:38:57  pg
 * intital version
 *
 *
 */
