/*
 * $Id: SenseObject.java,v 1.6 2002/07/08 04:27:22 pg Exp $
 *
 */

/**
 * Objektklasse.
 * speichert "sense-" Daten vom server
 * @author Patrick Gaertner (pg)
 * @author Florian Grassel (fg)
 *
 */

public class SenseObject
	extends WorldObject
{
	
	// Attribute
	/** Ausdauer des Spielers */
	private double stamina = 0;
    /** aktuelle Kopfdrehung des Spielers */
	private double headangle = 0;
    /** approximierte Laufgeschwindigkeit */
	private double speedamount = 0;
    /** Laufrichtung */
	private double speeddirection = 0;
    /** aktueller tick */
	private int timestep ;
	
    /** Konstruktor. setzt isC
	 * @author pg
	 * @see WorldObject
     */
	public SenseObject()
	{
		setIsC(false);
	}
	
	// get & set Methoden
	/** giebt die Ausdauer zurueck
	 * @author pg
	 * @return stamina die Ausdauer
	 */
	public double getStamina()
	{
		return this.stamina;
	}
	
    /** gibt die Kopfdrehung zurueck
     * @author pg
     * @return headangle die Kopfdrehung
     */
	public double getHeadangle()
	{
		return this.headangle;
	}
	
    /** gibt die approximierte Laufgeschwindigkeit zurueck
     * @author pg
     * @return speedamount die Laufgeschwindigkeit
     */
	public double getSpeedamount()
	{
		return this.speedamount;
	}
	
    /** gibt die Laufrichtung zurueck
     * @author pg
     * @return speeddirection die Laufgeschwindigkeit
     */
	public double getSpeeddirection()
	{
		return this.speeddirection;
	}
	
    /** setzt die Ausdauer
     * @author pg
     * @param sta Wert der stamina zugewiesen wird
     */
	public void setStamina(double sta)
	{
		this.stamina = sta;
	}
	
    /** setzt die Kopfdrehung
     * @author pg
     * @param angle Wert der headangle zugewiesen wird
     */
	public void setHeadangle(double angle)
	{
		this.headangle = angle;
	}
	
    /** setzt dei approximierte Laufgeschwindigkeit
     * @author pg
     * @param spdamnt Wert der der Laufgeschwindigkeit zugewiesen wird
     */
	public void setSpeedamount(double spdamnt)
	{
		this.speedamount = spdamnt;
	}
	
    /** setzt die Laufrichtung
     * @author pg
     * @param dir Winkel der der Laufrichtung zugewiesen wird
     */
	public void setSpeeddirection(double dir)
	{
		this.speeddirection = dir;
	}
	
    /** gibt den aktuellen tick zurueck
     * @author fg
     * @return timestep der tick
     */
	public int getTimestep()
	{
	  return timestep;
	}
	
    /** setzt den aktuellen tick
     * @author fg
     * @param step wert der timestep zugewiesen wird
     */
	public void setTimestep(int step)
	{
	  timestep=step;
	}
}

/*
 * $Log: SenseObject.java,v $
 * Revision 1.6  2002/07/08 04:27:22  pg
 * JavaDoc kommentiert =) final Version
 *
 * Revision 1.5  2002/07/07 16:15:27  fg
 * Timestep eingebaut
 *
 * Revision 1.4  2002/06/25 16:31:10  fg
 * Stamina ist double nicht int, wurde geaendert
 *
 * Revision 1.3  2002/06/12 11:06:47  pg
 * SETISC!!!!!!!!!!!!!!!!!!
 *
 * Revision 1.2  2002/06/10 12:25:29  pg
 * eigentlich nur isC geaendert, aber eigentlich schon mal commitet...???
 *
 * Revision 1.1.1.1  2002/06/05 10:38:57  pg
 * intital version
 *
 *
 */

