/* 
 * $Id: Spielfeld.java,v 1.7 2002/07/08 07:34:39 fg Exp $
 *
 */

/*
 * Klasse zur Visualisireung des Weltbildes.
 * zusatztool ohne einfluss auf das Spielverhalten der einzelnen player oder
 * das Gesamtverhalten der mannschaft.
 * @author Florian Grassl
 */

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;

class Spielfeld extends JComponent
{
  private int groesse = 10;
  private JLabel[] player = new JLabel[11];
  private JLabel[] enemy = new JLabel[11];
  private JLabel ball;
  private JLabel me; 
  
  Spielfeld()
  {
	  setLayout(null);
	  JLabel spielfeld = new JLabel(new ImageIcon("Rasen.gif"));
	  spielfeld.setOpaque(false);
	  for (int i=0; i< 11; i++)
	  {
  	  player[i]=new JLabel(""+(i+1), JLabel.CENTER);
	    player[i].setForeground(Color.black);
	    player[i].setBackground(Color.blue);
  	  player[i].setOpaque(true);
      player[i].setFont(new Font("Serif", Font.PLAIN, groesse));
    	player[i].setBounds(0, 0, groesse, groesse);
    	player[i].setVisible(false);
    	add(player[i]);
  	  enemy[i]=new JLabel(""+(i+1), JLabel.CENTER);
	    enemy[i].setForeground(Color.black);
	    enemy[i].setBackground(Color.red);
  	  enemy[i].setOpaque(true);
      enemy[i].setFont(new Font("Serif", Font.PLAIN, groesse));
    	enemy[i].setBounds(0, 0, groesse, groesse);
    	enemy[i].setVisible(false);
    	add(enemy[i]);
    }
    ball = new JLabel("B", JLabel.CENTER);
    me = new JLabel("M", JLabel.CENTER);
	  ball.setForeground(Color.black);
	  ball.setBackground(Color.white);
	  ball.setOpaque(true);
	  ball.setFont(new Font("Serif", Font.PLAIN, groesse));
	  ball.setBounds(0, 0, groesse, groesse);
	  ball.setVisible(false);
	  me.setForeground(Color.black);
	  me.setBackground(Color.yellow);
	  me.setOpaque(true);
	  me.setFont(new Font("Serif", Font.PLAIN, groesse));
	  me.setBounds(0, 0, groesse, groesse);
	  me.setVisible(false);
  	spielfeld.setBounds(0,0,575,390);
	  add(me);
    add(ball);
    add(spielfeld);
  }
    
  private int koordTransformX(int original)
  {
    return ((original+575)/2)-(groesse/2);
  }
  
  private int koordTransformY(int original)
  {
    return -((original-390)/2)-(groesse/2);
  }

  public void setPlayerPos(int nr, XyObject pos)
  {
    if (nr-1 < player.length)
    {
      if (pos.getX() == 4444 && pos.getY() == 4444)
        player[nr-1].setVisible(false);
      else
      {
        player[nr-1].setBounds(koordTransformX(pos.getX()), koordTransformY(pos.getY()), groesse, groesse);
        player[nr-1].setVisible(true);
      }
    }
  }
   
  public void setEnemyPos(int nr, XyObject pos)
  {
    if (nr-1 < enemy.length)
    {
      if (pos.getX() == 4444 && pos.getY() == 4444)
        enemy[nr-1].setVisible(false);
      else
      {
        enemy[nr-1].setBounds(koordTransformX(pos.getX()), koordTransformY(pos.getY()), groesse, groesse);
        enemy[nr-1].setVisible(true);
      }
    }
  }
    
  public void setBallPos(XyObject pos)
  {
    if (pos.getX() == 4444 && pos.getY() == 4444)
      ball.setVisible(false);
    else
    {
      ball.setBounds(koordTransformX(pos.getX()), koordTransformY(pos.getY()), groesse, groesse);
      ball.setVisible(true);
    }
  }

  public void setSelfPos(XyObject pos)
  {
    if (pos.getX() == 4444 && pos.getY() == 4444)
      me.setVisible(false);
    else
    {
      me.setBounds(koordTransformX(pos.getX()), koordTransformY(pos.getY()), groesse, groesse);
      me.setVisible(true);
    }
  }
    
  public void setGroesse(int groesse)
  {
    this.groesse = groesse;
  }
      
  public void clearAll()
  {
    for (int i=0; i<11; i++)
    {
      player[i].setVisible(false);
      enemy[i].setVisible(false);
    }
    me.setVisible(false);
    ball.setVisible(false);
  }
}

/*
 * $Log: Spielfeld.java,v $
 * Revision 1.7  2002/07/08 07:34:39  fg
 * *** empty log message ***
 *
 * Revision 1.6  2002/07/03 17:30:02  fg
 * Spieler heisen jetzt 1, 2, 3 und nichtmehr 11, 21, 31, usw :)
 *
 * Revision 1.5  2002/07/03 16:45:20  fg
 * Grafische implementierung erledigt
 *
 * Revision 1.4  2002/07/02 13:22:04  fg
 * *** empty log message ***
 *
 */
