/*
 * $Id: Visualisierung.java,v 1.10 2002/07/08 07:33:25 fg Exp $
 *
 */

/*
 * Klasse zur Visualisireung des Weltbildes.
 * zusatztool ohne einfluss auf das Spielverhalten der einzelnen player oder
 * das Gesamtverhalten der mannschaft.
 * @author Florian Grassl (fg)
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Visualisierung extends JPanel implements Runnable
{
    /** Ausgewhlter Spieler. 12 fr Feld Alle */
    public int activePlayer;
    /** true wenn neuer Spieler ausgewhlt */
    private boolean newActive = false;
    /** Referenzen auf die 11 Player-Objekte*/
    private Player[] player;
    /** aktuelles Overview */
    private OverviewObject OV;
    /** Referenz auf das Datenblatt (die "Textausgabe") */
    private Datenblatt db;
    /** Das Spielfeld (grafische anzeige) */
    private Spielfeld sf;
    /** Grsse der icons */
    private int groesse = 10;
    /** Zum einstellen der Refreshrate */
    private JTextField refresh;
    
    /** Wird gestartet, wenn der Thread gestartet wird */    
    public void run()
    {  
	    JFrame f = new JFrame("Visualisierung");
      Visualisierung v = new Visualisierung();
      f.getContentPane().add(v);
	    f.setSize(1024,600);
      f.setVisible(true); 
    	while (true)
	    {
	      try
	      {
           Thread.currentThread().sleep(v.getRefresh());
        }
        catch (InterruptedException e)
        {
        }
	      int spNr=v.getActive();
	      if (spNr == 12) //Alle Spieler
	      {
          db=v.getDatenblatt();
          sf=v.getSpielfeld();
          if (v.getNewActive()) sf.clearAll();
          for (int i=1; i <=11; i++)
	        {
	          OV = player[i-1].getOverview();
  		      if (OV == null)
            {
	            System.err.println("Visualisierung: OverviewObject Nullpointer!!");
    	      }
            else
            {
              if (OV.getSelfPos() != null)
              {
                sf.setPlayerPos(i, OV.getSelfPos());
                db.setPlayer(i, OV.getSelfPos().getX()+" , "+OV.getSelfPos().getY()+" , "+OV.getBodyangle());
              }
            }
            db.setEnemy(i, "Egal :-)");
            sf.setEnemyPos(i, new XyObject(4444,4444));
          }
	        db.setSelfPos("");
	        db.setBallPos("");
	        db.setSpielernummer("");
	        db.setStamina("");
	        db.setHeadAngle("");
	        db.setBodyAngle("");
	        db.setTarget("");
	        db.setAnzUnbekannt("");
  	      sf.setBallPos(new XyObject(4444,4444));
  	      sf.setSelfPos(new XyObject(4444,4444));
        }
        else
        {
  	      OV = player[spNr-1].getOverview();
	        if (OV == null)
          {
	          System.err.println("Visualisierung: OverviewObject Nullpointer!!");
    	    }
  	      else
          {
	          db=v.getDatenblatt();
	          sf=v.getSpielfeld();
            if (v.getNewActive()) sf.clearAll();
            sf.setGroesse(v.getGroesse());
            for (int i=1; i <= 11; i++)
            {
              if (OV.get1PlayerPos(i-1) != null)
              {
                db.setPlayer(i, OV.get1PlayerPos(i-1).getX()+","+OV.get1PlayerPos(i-1).getY());
                if (i != spNr)
                  sf.setPlayerPos(i, OV.get1PlayerPos(i-1));
              }
              if (OV.get1EnemyPos(i-1) != null)
              {
                db.setEnemy(i, OV.get1EnemyPos(i-1).getX()+","+OV.get1EnemyPos(i-1).getY());
                sf.setEnemyPos(i, OV.get1EnemyPos(i-1));
              }
            }
  	        db.setSelfPos(OV.getSelfPos().getX()+","+OV.getSelfPos().getY());
	          db.setBallPos(OV.getBallPos().getX()+","+OV.getBallPos().getY());
	          db.setSpielernummer(""+OV.getMe());
	          db.setStamina(""+OV.getStamina());
	          db.setHeadAngle(""+OV.getHeadangle());
	          db.setBodyAngle(""+OV.getBodyangle());
            if (OV.getTarget() != null)
    	        db.setTarget(OV.getTarget().getX()+","+OV.getTarget().getY());
            if (OV.getUnknownPos() != null)
  	          db.setAnzUnbekannt(""+OV.getUnknownPos().length);
  	        sf.setBallPos(OV.getBallPos());
  	        sf.setSelfPos(OV.getSelfPos());
  	      } 
        }
      }
    }
    
    /** Konstruktor wird vom Main aufgerufen
     *  @param player Referenzen auf alle 11 Player-Objekte
     */
    public Visualisierung(Player[] player)
    {
	    this.player = player;
    }
    
    /** Konstruktor wird aus der run() aufgerufen um die Visualisierung zu malen
    */
    public Visualisierung()
    {
	    setLayout(new BorderLayout());
	    Box b = Box.createHorizontalBox();
	    b.setSize(575,20);
	    ButtonGroup bg = new ButtonGroup();
	    activePlayer=1;
	    final JRadioButton[] but = {
	      new JRadioButton("1",true),
	      new JRadioButton("2"),
   	    new JRadioButton("3"),
	      new JRadioButton("4"),
	      new JRadioButton("5"),
  	    new JRadioButton("6"),
	      new JRadioButton("7"),
	      new JRadioButton("8"),
	      new JRadioButton("9"),
  	    new JRadioButton("10"),
	      new JRadioButton("11"),
	      new JRadioButton("Alle")
	    } ;
	    JLabel refLabel = new JLabel("Refresh-Rate (100-2000 ms):");
	    refresh = new JTextField("500",4);
	    final JCheckBox cb = new JCheckBox("Groe Spieler");

	    ItemListener lis = new ItemListener()
    	{
	      public void itemStateChanged(ItemEvent e)
	      {
    		  if (e.getStateChange() == ItemEvent.SELECTED)
		        for (int i=0; i < but.length; i++)
			        if (but[i].isSelected())
			        {
			          //System.out.println(but[i].getText() + " selektiert");
                if (but[i].getText().equals("Alle"))
                {
                  activePlayer = 12;
                }
                else
                {
			            activePlayer = Integer.parseInt(but[i].getText());
			          }
			          newActive = true;
			        }
  	    }
	    };
	    ItemListener lis2 = new ItemListener()
    	{
	      public void itemStateChanged(ItemEvent e)
	      {
		      //		if (e.getStateChange() == ItemEvent.SELECTED)
		      if (cb.isSelected())
		        groesse = 15;
		      else
	          groesse = 10;
   	    }
	    };
      for (int i = 0; i < but.length ; i++)
	    {
	      but[i].addItemListener(lis);
  	    bg.add(but[i]);
	      b.add(but[i]);
	    }
	    b.add(Box.createHorizontalGlue());
	    b.add(refLabel);
	    b.add(refresh);
	    b.add(cb);
	    cb.addItemListener(lis2);
      add(b, BorderLayout.NORTH);
	    sf = new Spielfeld();
	    add(sf); 
	    db = new Datenblatt();
	    add(db, BorderLayout.EAST);
    }
    
    /** Liefert die eingestellte Refreshrate zurck */
    private int getRefresh()
    {
      int refr;
      try 
      { 
        refr = Integer.parseInt(this.refresh.getText()); 
      }
      catch (Exception e) 
      {
        return 100;
      }
      if (refr < 100) refr = 100;
      if (refr > 2000) refr = 2000;
      return refr;
    }
    
    /** Liefert ausgewhlten Spieler zurck
     */
    private int getActive()
    {
	    return this.activePlayer;
    }

    /** Liefert Datenblatt Objekt zurck
     */
    private Datenblatt getDatenblatt()
    {
	    return this.db;
    }

    /** Liefert Spielfeld Objekt zurck
     */
    private Spielfeld getSpielfeld()
    {
	    return this.sf;
    }

    /** Liefert ausgewhlte Grsse zurck
     */
    private int getGroesse()
    {
      return groesse;
    }
    
    /** Liefert zurck, ob ein neuer spieler seit der letzten Abfrage ausgewhlt wurde, damit alle Icons gelscht werdne.
     */
    private boolean getNewActive()
    {
      if (this.newActive)
      {
        this.newActive = false;
        return true;
      }
      else
        return false;
        
    }
	    

}


/*
 * $Log: Visualisierung.java,v $
 * Revision 1.10  2002/07/08 07:33:25  fg
 * Kommentiert
 *
 * Revision 1.9  2002/07/05 17:44:48  fg
 * Bodyangle wird bei Alle numerisch angegeben
 *
 * Revision 1.8  2002/07/05 17:38:29  fg
 * Man kann jetzt einstellen, alle Self-Pos gleichzeitig zu sehen
 *
 * Revision 1.7  2002/07/03 17:31:42  fg
 * - Flimmern abgestellt
 * - Refresh-Rate ist per TextField zwischen 100 ms und 2000ms einstellbar
 * - CheatMode-Button wurde ersetzt durch "Grosse Spieler" womit alle Icons vergrssert dargestellt werden.
 *
 * Revision 1.6  2002/07/03 16:46:29  fg
 * Grafische implementierung
 *
 * Revision 1.5  2002/07/02 21:13:58  fg
 * Player und Enemys werden jetzt korrekt dargestellt
 *
 * Revision 1.4  2002/06/25 20:36:59  fg
 * Aktuelle Werte aus dem OverviewObject werden gesetzt
 *
 * Revision 1.3  2002/06/25 16:31:30  fg
 * *** empty log message ***
 *
 * Revision 1.2  2002/06/18 10:39:57  fg
 * Noch Stand-Alone anwendung
 *
 * Revision 1.1.1.1  2002/06/05 10:38:57  pg
 * intital version
 *
 *
 */

