/*
* $Id: Weltbild.java,v 1.77 2002/07/14 12:01:40 sg Exp $
*
*/
/**
 *
* Orientierungsklasse.
* erstellt das zur orientierung und zur taktischen beurteilung notwendige OverviewObject.
* @author Marcus Schumacher (ms)
* @ Jens Spies (js)
*/
import java.lang.Math;
public class Weltbild extends Thread
 {
   // Referenzen
  /**Referenz auf das Gedaechtnis*/
   private Gedaechtnis gedenk;
   /** Referenz auf den Player */
   private Player play;
   // Attribute
   /**Position des Balles    */
   private XyzObject ballPos       = new XyzObject();
   /**eigene Position*/
   private XyzObject selfPos       = new XyzObject();
   /**Positionen der anderen Mitspieler*/
   private XyzObject[] playerPos   = new XyzObject[11];
   /**Positionen der gegnerischen Spieler*/
   private XyzObject[] enemyPos	   = new XyzObject[11];
   /**Positionen unbekannter Spieler*/
   private XyzObject[] unknownPos;

   private OverviewObject aktOverview      = new OverviewObject();
   /** Das neue WorldObject und das, mit denen spter in den Methoden gearbeitet wird*/
   private WorldObject aktWO;
   private WorldObject aktWait;
   /** Speichert, ob ein neues WorldObject vorhanden ist, oder nicht*/
   private boolean isNewWO = false;
   /**speichert die absoluten Winkel*/
   private double bodyAngle;
   double absWinkel;
   /** Arrays um bei der Initialisierung die cos und sin Werte zu speichern */
   double[] sin = new double[451];
   double[] cos = new double[451];
   /**wurde der Ball aktuell gesehen ja/nein */
   boolean seeBall = false;
   /**speichert, ob als letztes ein See oder SenseObject empfangen wurde (ja/nein)*/
   boolean issee = false;
   /**speichert den Ballwinkel vom Spieler zum Ball*/
   private double ballWinkel=0;
   double stamina = 0;
   double Headangle =0;

   int spnr=12;
   /**wird in den Methoden getplayerPos und getenemypos verwendet, damit nur die nchsten 5
    * Runden im Gedchtnis nachgeschaut wird*/
   int ballverlauf   = 0;
   int enemyverlauf  = 0;
   int playerverlauf = 0;
   /**speichert die approximierte Geschwindigkeit des Spielers*/
   private double speedAmount;
   int timestep = 0;


   /** setzen der absoluten Koordinaten der Flags, welche zur Bestimmung der eigene Position und
   *  der der Mitspieler bzw. gegnerischen Spieler bentigt werden */
   private XyObject[] flags  = {(new XyObject(0,-390)),     (new XyObject(-100,-390)),(new XyObject(-200,-390)),(new XyObject(-300,-390)),
                                (new XyObject(-400,-390)),  (new XyObject(-500,-390)),(new XyObject(-575,-300)),(new XyObject(-575,-200)),
                                (new XyObject(-575,-100)),  (new XyObject(-575,0)),   (new XyObject(-575,100)), (new XyObject(-575,200)),
                                (new XyObject(-575,300)),   (new XyObject(-500,390)), (new XyObject(-400,390)), (new XyObject(-300,390)),(new XyObject(-200,390)),
                                (new XyObject(-100,390)),   (new XyObject(0,-340)),   (new XyObject(-525,-340)),(new XyObject(-525,-70)),
                                (new XyObject(-525,0)),     (new XyObject(-525,70)),  (new XyObject(-525,340)), (new XyObject(-360,-200)),
                                (new XyObject(-360,0)),     (new XyObject(-360,200)), (new XyObject(0,0)),(new XyObject(360,-200)),(new XyObject(360,0)),
                                (new XyObject(360,200)),    (new XyObject(525,-340)), (new XyObject(525,-70)),(new XyObject(525,0)),   (new XyObject(525,70)),
                                (new XyObject(525,340)),    (new XyObject(0,340)),    (new XyObject(100,-390)), (new XyObject(200,-390)),(new XyObject(300,-390)),
                                (new XyObject(400,-390)),   (new XyObject(500,-390)), (new XyObject(575,-300)), (new XyObject(575,-200)),
                                (new XyObject(575,-100)),   (new XyObject(575,0)),    (new XyObject(575,100)),  (new XyObject(575,200)), (new XyObject(575,300)),
                                (new XyObject(500,390)),    (new XyObject(400,390)),  (new XyObject(300,390)),  (new XyObject(200,390)),
                                (new XyObject(100,390)),    (new XyObject(0,390)),};
   private XyzObject aPos;
   private boolean sleepMode = false;
  // Konstruktor
 public Weltbild(Player playIn)
    {
      this.play = playIn;
      this.gedenk = new Gedaechtnis(this.play, this);
    }
 /** berschreibt die run Methode der Threadklasse
 * @author ms
 */
 public void run()
   {
      this.sleepMode = false;

      /* hier werden die Arrays cos und sin beim initialisieren angelegt,
       * um spter Rechenzeit zu sparen
      */
      for (int i=-90; i<361;i++)
        {
           sin[i+90] = Math.sin(Math.toRadians(i));
           cos[i+90] = Math.cos(Math.toRadians(i));
         }
       String[] serverpar = play.getServerParam().getValueArray();

             /** Holt aus den ServerParamObj das Array, um die Information bzgl
              *  der Torbreite zu bekommen und setzt die Flags dementsprechend
              */
             double pfostenb = Double.parseDouble(serverpar[1]);
             pfostenb = (pfostenb/2)*10;
             this.flags[20].setY(-(int)pfostenb);
             this.flags[22].setY((int)pfostenb);
             this.flags[32].setY(-(int)pfostenb);
             this.flags[34].setY((int)pfostenb);

       play.setWeltbildThread(currentThread());
       while(true)
          {
              while (this.isNewWO ==false)
                 {
                      // Thread.yield();
                      try
                      {
                        this.sleepMode = true;
                        currentThread().sleep(5);
                      }
                      catch (InterruptedException e)
                      {
                      }
                      this.sleepMode= false;
                   }
              // Hier wird berprft, ob ein See oder ein SenseObject vorliegt

             // Holt die Spielernr des Spielers
             this.spnr = play.getSpielernummer();


             /** falls ein SeeObject empfangen wurde fhre folgende Aktionen durch*/
             if (this.aktWait.getIsC() == true)
               {

                this.aktWO      = this.aktWait;
		            this.isNewWO    = false;
                this.selfPos    = getSelfPos();  //bestimme deine eigene Position
                this.ballPos    = getBallPos();  //wo liegt der Ball
                this.enemyPos   = getEnemyPos(); // wo stehn die gegnerische Spieler
                this.playerPos  = getPlayerPos();// wo stehen meine Mitspieler
                this.issee      = true;


               }

             /** falls ein Sense Object empfange wurde*/
             if (this.aktWait.getIsC() == false)
             {
    		            this.isNewWO    = false;
                    this.aktWO     = this.aktWait;
                    this.stamina   = ((SenseObject)this.aktWO).getStamina();  //wie fit bin ich noch
                    this.Headangle = ((SenseObject)this.aktWO).getHeadangle(); // wie ist mein Kopf gedreht
                    this.speedAmount = ((SenseObject)this.aktWO).getSpeedamount(); // wie schnell bin ich gerade ungefhr
                    this.aktOverview = aktualisierenOV(aktOverview);  // aktualisiere das OV
                    this.aktOverview.setHear(play.getLastHear()); //was habe ich gehrt
                    this.play.incomOV(aktOverview);
                    // setze das OV ins Gedaechtniss nur dann, wenn auch aktuelle See-Nachrichten vorhanden sind
                    if (this.issee == true)
                    {
                    this.gedenk.setOV(aktOverview);   //behalte die letzten Informationen im "Kurzzeitgedchtnis"
                    }
                    this.gedenk.setLastHear(play.getLastHear());  // ""
                    this.timestep = ((SenseObject)this.aktWO).getTimestep();
                    this.issee = false;

                    }
               }
         }
public Thread getThread()
{
    return currentThread();
}
// get & set Methoden
public Player getPlay()
 {
    return this.play;
 }
public Gedaechtnis getGedenk()
  {
        return this.gedenk;
  }


/** bestimmt die absolute Position des Balles
* @author ms
* @return ballPos liefert die Ballposition entweder selbst gesehen oder durchs Gedchtnis interpoliert
*/
public XyzObject getBallPos()
  {
      // holt sich die Infos aus dem SeeObject
      double[] ballp = ((SeeObject)this.aktWO).getBall();
      XyzObject ballpo = new XyzObject();

      // falls der Ball gesehen wird, dann berrechne seine Pos
      if ( ballp[0] != 4444 && ballp[0] != -3333)
      {
          ballpo.setX((int)berechnePosX(ballp[0], ballp[1]));
          ballpo.setY((int)berechnePosY(ballp[0], ballp[1]));
		      this.seeBall = true;
          this.ballWinkel = ballp[1];
          this.ballverlauf = 0;

       }
        else
        {
          //setze die Variable dementsprechend, dass der Ball nicht gesehen wurde
            this.seeBall = false;
            // falls der Ball im 3m Radius hinter einem liegt bestimme ungefhr seine Pos
		if (ballp[0] == -3333)
         {
                double entf = -1.5;
                ballpo.setX((int)berechnePosX(entf, ballp[1]));
                ballpo.setY((int)berechnePosY(entf, ballp[1]));
                this.ballWinkel = ballp[1];
                this.ballverlauf = 0;

         }
    // ansonsten sieh im Gedaechtniss nach
         else
         {
             if (this.ballverlauf <=3)
             {
             ballpo = this.gedenk.intplBallPos();
             this.ballWinkel = 4444;
             this.ballverlauf +=1;
             }
         }
       }
      /** rufe die Methode extrapl im Gedaechtnis auf um die SetA und SetB zu fllen */
	  ballpo = this.gedenk.extrapl(ballpo);

     return ballpo;
  }

/** Betimmt die eigene Position indem die Methode berechneSelfPos aufgerufen wird, welche
 *  die absoluten koordinaten zurckgibt
 * @author ms
 * @return selfPos liefert die eigene Position, welche von berechneSelfPos() bestimmt wird
 *
 */
 public XyzObject getSelfPos()
   {
        this.selfPos = berechneSelfPos(this.aktWO);
        return this.selfPos;
   }

 /** bestimmt die absoluten Positionen der eigenen Mitspieler
 * @author ms
 * @return playerPos liefert die Positionen der eigenen Mitspieler
 */
public XyzObject[] getPlayerPos()
   {
      // holt sich die Infos aus dem SeeObject
      double[][] pos = ((SeeObject)this.aktWO).getPlayers();
      XyzObject[] player = new XyzObject[11];
      int i,j;
      j = pos.length;
      for (i=0; i<j ; i++)
         {
            player[i] = new XyzObject();
            //Wenn ich die Spieler sehe, bestimme die Position
   		    if (pos[i][0] != 4444 && pos[i][0] != -3333 )
                {
                       player[i].setX((int)berechnePosX(pos[i][0],pos[i][1]));
                       player[i].setY((int)berechnePosY(pos[i][0],pos[i][1]));
                       this.playerverlauf = 0;
                }
            else
            {
                // falls ich die Spieler nicht sehe, ruf das Gedaechtnis auf, wo sie ungefhr sein knnten
                if (this.playerverlauf <= 5)
                    {
                        player[i] = this.gedenk.intplPlayerPos(i);
                        this.playerverlauf += 1;
                    }
                // Wenn ich die Spieler schon seit 5 Runden nicht mehr gesehen habe
                // dann hab ich wirklich keine Ahnung mehr wo sie sein knnten
                    else
                    {
                       player[i].setX(4444);
                       player[i].setY(4444);
                    }
                }

	    	    }
       return player;
    }

/** liefert die Position eines einzelnen Mitspielers
 * @author ms
 * @return playerPos[no] liefert die Positione eines einzelnen Spielers
*/
public XyzObject get1PlayerPos(int no1)
   {
       int no = no1;
       double[][] pos = ((SeeObject)this.aktWO).getPlayers();

       if (pos[no][0] != 4444 )
            {
                this.playerPos[no].setX((int)berechnePosX(pos[no][0],pos[no][1]));
                this.playerPos[no].setY((int)berechnePosY(pos[no][0],pos[no][1]));
            }
        else
            {
                    this.playerPos[no].setX(4444);
			        this.playerPos[no].setY(4444);
            }
        return this.playerPos[(no)];
        }
/** bestimmt die absoluten Positionen der gegnerischen Spieler
* @author ms
* @return enemyPos liefert die Positionen der gegnerischen Spieler
*/
public XyzObject[] getEnemyPos()
  {
                // holt sich die Infos aus dem SeeObject
                double[][] pos = ((SeeObject)this.aktWO).getEnemys();
                XyzObject[] enemy = new XyzObject[11];
                int i,j;
                j = pos.length;
                for (i=0; i<j ; i++)
                {
                    enemy[i] = new XyzObject();
           //Wenn ich die geg. Spieler sehe, bestimme die Position
		    if (pos[i][0] != 4444 && pos[i][0] != 0)
			{
                        enemy[i].setX((int)berechnePosX(pos[i][0],pos[i][1]));
                        enemy[i].setY((int)berechnePosY(pos[i][0],pos[i][1]));
                        this.enemyverlauf = 0;
			}
		    else
            {
                // falls ich die geg. Spieler nicht sehe, ruf das Gedaechtnis auf, wo sie ungefhr sein knnten
                if (this.enemyverlauf <=5)
                {
                enemy[i] = this.gedenk.intplEnemyPos(i);
                this.enemyverlauf +=1;
                }
                 // Wenn ich die geg. Spieler schon seit 5 Runden nicht mehr gesehen habe
                // dann hab ich wirklich keine Ahnung mehr wo sie sein knnten
                else
                {
                    enemy[i].setX(4444);
                    enemy[i].setY(4444);
                }
            }
                }
                return enemy;
        }

    /** liefert die Positionen aller unbekannten Spieler, sowohl derer, die auerhalb
     * der Sichtweite liegen, als auch derer, die im 3m Radius hinter einem stehn
     * @author ms
     * @return unknownPos liefert die Positionen der unbekannten Spieler
     */
    public XyzObject[] getUnknownPos()
        {
                // holt sich die Infos aus dem SeeObject
                double[][] pos = ((SeeObject)this.aktWO).getUnknowns();
                XyzObject[] unknown = new XyzObject[22];
                int i,j;
                j = pos.length;
                for (i=0; i<=j ; i++)
                {
                    unknown[i] = new XyzObject();
                    //Sehe ich zwar den Spieler, hab aber keine Ahnung wer er ist, bestimme trotzdem seine Pos
                    if (pos[i][0] != 4444 && pos[i] != null && pos[i][0] != -3333)
                    {
                        unknown[i].setX((int)berechnePosX(pos[i][0],pos[i][1]));
                        unknown[i].setY((int)berechnePosY(pos[i][0],pos[i][1]));

                    }
                    else
                    {
                        // Wenn er hinter mir steht, betimme zumindest ungefhr seine Pos
                        if (pos[i][0] == -3333)
                        {
                            double entf = -1.5;
                            unknown[i].setX((int)berechnePosX(entf,pos[i][1]));
                            unknown[i].setY((int)berechnePosY(entf,pos[i][1]));
                        }
                        else
                        {
                        unknown[i].setX(4444);
                        unknown[i].setY(4444);
                        }
                    }
                }

                return unknown;
        }


    // Methoden

        /** wird vom Player aus aufgerufen und bergibt das aktuelle WorldObject
         * @author ms
         */
        public boolean aktualisieren(WorldObject aktWOin)
        {
                this.aktWait = aktWOin;
                this.isNewWO = true;  //isNewWO : ein neues WorldObject ist angekommen!!
                return this.sleepMode;
        }

     /** schreibt das aktuelle OverviewObject, welches dann an
      *  den Player gegeben und von der Taktik weiterverwendet wird
      * @author ms
      * @return aktOV das neue und aktuelle OverviewObject
      */
        public OverviewObject aktualisierenOV(OverviewObject aktOV)
        {
                // setzen der einzelnen Variablen im OverviewObject (OV)
                aktOV = new OverviewObject();
                aktOV.setMe(this.spnr);
                aktOV.setSpielmodus(play.getSpielmodus());
                aktOV.setBallPos(this.ballPos);
                aktOV.setSpeedAmount(this.speedAmount);
                aktOV.setSelfPos(this.selfPos);
                aktOV.setEnemyPos(this.enemyPos);
                aktOV.setPlayerPos(this.playerPos);
                if (play.lastTimeTurn())
				{
				     play.lastTurnBoolean = false;
				     double temp = (360+play.lastTurn+play.getBodyMom()-this.Headangle);
				     if (temp >= 720) temp = temp % 720;
				   	 else temp = temp % 360;
				     aktOV.setBodyangle(temp);
				}
                else aktOV.setBodyangle((360+(play.getBodyMom()-this.Headangle))%360);
                aktOV.setSeeBall(seeBall);
                aktOV.setBallWinkel(this.ballWinkel);
                aktOV.setTimestep(this.timestep);
                aktOV.setStamina(this.stamina);
                aktOV.setHeadangle(this.Headangle);
                return aktOV;
        }

    // interne Methoden


  private int auffuellen(int u, int wert)
  {
    return wert-u-1;
  }


/** Berechnet die eigene Position anhand der Flags, in dem der absolute Winkel von der Flag zum
 *  Spieler berechnet wird und dann ber den Einheitskreis die eigene Position bestimmt wird
 * @author js
 * @author ms
 * @return self  die eigene Position
 */
  private XyzObject berechneSelfPos(WorldObject neuWO)
  {
    int gesFlags = 1 ; // Anzahl der Flags die zur PosBerechnung herangezogen werden sollen
    double[][] flags = ((SeeObject)neuWO).getFlags();
    XyzObject self = new XyzObject();
    int[] nr = new int[gesFlags];
    double[] min = new double[gesFlags];
    int nrTemp;
    double minTemp;
    for (int h=0;h < gesFlags;h++)
    {
      nr[h]=90;
      min[h]=5555;
    }

    // Hier wird die Flag gesucht, die dem Spieler am nchsten ist um die Genauigkeit zu erhhen
    for (int e = gesFlags-1 ;e>=0 ; e--)
    {
      for (int i=0; i<55 ; i++)
      {
        if (min[e]>flags[i][0])
        {
          for (int u=e; u < gesFlags; u++)
          {
            for (int q=0 ; q<=auffuellen(u,gesFlags);q++)
            {
              if (u+q != gesFlags-1)
              {

                nrTemp = nr[u+q];
                minTemp = min[u+q];
                nr[u+q] = i;
                min[u+q] = flags[i][0];
                nr[u+q+1] =nrTemp;
                min[u+q+1] = minTemp;
              }
              else
              {
                nr[u+q]=i;
                min[u+q]=flags[i][0];
              }
            }
          }
        }
      }
    }
      if (gesFlags>1) for (int l=1; l<gesFlags; l++)
      {
        //if (play.getspielernummer==
        if (nr[l]==nr[l-1] || nr[l-1]==90) nr[l]=90;
      }
      // Ab hier beginnt die eigentlich Pos-Bestimmung:
      int g = 0;
      int Xschnitt=-1;
      int Yschnitt=-1;
      double[] lineinfos = ((SeeObject)neuWO).getLine();
      int[] X = new int[3];
      int[] Y = new int[3];
      for (int h=0; h<3;h++) {X[h]=0; Y[h]=0;}
      int flaggy = 0;
      for (int j=0; j<gesFlags; j++)
      {
        if (nr[j]!=90) flaggy=flaggy+1;
      }
      for (g=0; g<flaggy; g++)
      {
        if (lineinfos[2] != 0 && nr[g] != 90 )
        {
          double lineWnkl = lineinfos[1];
          double relFlWnkl=flags[nr[g]][1];
          double absFlWnkl=666666;
          int flDist= (int)(flags[nr[g]][0]*10);
          int flAbsX= (int)(this.flags[nr[g]].getX());
          int flAbsY= (int)(this.flags[nr[g]].getY());
          //Bestimmung der absoluten Krperdrehung (0 bzw. 360 ist das rechte Tor)
          if (lineWnkl>0) bodyAngle = lineinfos[2] * 90 - lineWnkl;
          else bodyAngle = ((lineinfos[2] + 2) % 4)*90 - lineWnkl;
          // das wars schon ;-)
          absFlWnkl = (bodyAngle + relFlWnkl)%360;    //Absoluter Winkel wo die Flag gesehen wird
          int temp = (int)absFlWnkl;              //Winkel zum rechnen
      	  //  Berechnung der X und Y - Koordinaten
          int rechnung = (int)Math.ceil(absFlWnkl/90);
          if (rechnung==0 || rechnung==1) temp = (int)(absFlWnkl);
  	      if (rechnung==2 || rechnung==3) temp = (int)(180-absFlWnkl);
  		    if (rechnung==4) temp = (int)(absFlWnkl-360);
          if (absFlWnkl>270 || absFlWnkl <90) X[g] = flAbsX - (int)(cos[temp+90] * flDist);
    		  else X[g] = flAbsX + (int)(cos[temp+90] * flDist);
          Y[g] = flAbsY + (int)(sin[temp+90] * flDist); // Bestimung der Y-Koordinate
        }
        else
        {
          self.setX(4444);
          self.setY(4444);
        }
      }
      if (flaggy!=0)
      {
        for (int r=0;r<flaggy;r++)
        {
          Xschnitt= Xschnitt + X[r];
          Yschnitt= Yschnitt + Y[r];
        }
        Xschnitt= Xschnitt/flaggy;
        Yschnitt= Yschnitt/flaggy;

        if (play.getSpielrichtung()=='r')
        {
          Xschnitt = -Xschnitt;
          Yschnitt = -Yschnitt;
          this.bodyAngle = (this.bodyAngle + 180)%360;
        } //spiegelung der koordinaten fr den Fall, dass von rechts nach links gespielt wird.
        play.setBodyMom(bodyAngle);
        this.absWinkel = 360 - bodyAngle;
        self.setX(Xschnitt);
        self.setY(Yschnitt);
      }
    return self;
  }
/** hier wird vom Player aus die neue dort ausgerechnete SelfPos gesetzt, da immer nur bei
 *  einem SeeObject die Pos absolut berrechnet werden kann, wird hier mehr oder weniger zu
 *  einem Schaetzwert (einem sehr guten aber!!!!)
 * @author ms
 *
 */
  public void setSelfPos(XyzObject neuSelfPos)
  {
    this.selfPos = neuSelfPos;
  }

  /** gleiches Verfahren wie bei der setSelfPos
   * @author ms
   */
  public void setBodyAngle(double neuBodyAngle)
  {
    this.bodyAngle = neuBodyAngle;
  }

  /** einfache Methode zur Berechnung der X-Koordinate
    * @author ms
    * @return x die gewnschte X-Koordinate
    */
 double berechnePosX (double dis2, double dir2)
   {
        double Winkel;
        double dir = dir2;
        double dis = dis2;
       // bestimme den absoluten Winkel zum Zielobject (Mitspieler, geg. Spieler,...)
        Winkel = this.absWinkel - dir;

        if (Winkel > 359) Winkel = Winkel - 360;
        if (Winkel < 0) Winkel = 360 + Winkel;
        //bestimme die X-Koordinate anhand des cos
        double x = this.selfPos.getX() + (this.cos[(int)Winkel+90] * (10*dis));
        return x;

   }

 /** einfache Methode zur Berechnung der Y-Koordinate
   * @author ms
   * @return y die gewnschte Y-Koordinate
   */
double berechnePosY (double dis3, double dir3)
   {
      double Winkel;
      double dir = dir3;
      double dis = dis3;
      // bestimme den absoluten Winkel zum Zielobject (Mitspieler, geg. Spieler,...)
      Winkel = this.absWinkel - dir;

      if (Winkel >= 360) Winkel = Winkel - 360;
      if (Winkel < 0) Winkel = 360 + Winkel;
      //bestimme die Y-Koordinate anhand des sin
      double y = this.selfPos.getY() + (this.sin[(int)Winkel+90] * (10*dis));
      return y;
   }
}


/*
 *$Log: Weltbild.java,v $
 *Revision 1.77  2002/07/14 12:01:40  sg
 *Auch hier eine ltere Version ausgecheckt.. Hren geht wieder.. Dazu wurde das Drehen gefixt
 *
 *Revision 1.73  2002/07/08 04:15:17  ms
 *-- war noch etwas ueberfluessiges auskommentiert -> entfernt
 *
 *Revision 1.72  2002/07/08 03:54:28  ms
 *- in der BallPos was vergessen :-)
 *
 *Revision 1.71  2002/07/08 03:20:45  ms
 *- Counter auch fr den Ball
 *
 *Revision 1.70  2002/07/08 02:56:53  ms
 *-- aufgeraeumt
 *-- getTorPos rausgeschmissen
 *
 *Revision 1.69  2002/07/08 01:57:23  ms
 *- weiter kommentiert
 *
 *Revision 1.68  2002/07/08 00:14:48  ms
 *-- neue BodyAngle wird vom Player aus gesetzt
 *
 *Revision 1.67  2002/07/07 22:19:12  ms
 *- speedamount wird gesetzt
 *
 *Revision 1.66  2002/07/07 17:33:27  ms
 *-- OV wird nur dann ins Gedaechtniss gesetzt, wenn auch
 *   eine aktuelle See-Nachricht vorhanden ist
 *
 *Revision 1.65  2002/07/07 16:15:11  fg
 *- Timestamp ins Senseobject verlegt
 *- setSelfPos fr Player eingefgt
 *
 *Revision 1.64  2002/07/07 14:58:08  js
 *Rungungsfehler behoben
 *
 *Revision 1.63  2002/07/07 14:37:49  fg
 *Fehler mit falschem Blickwinkel rausgemacht, dreht jetzt wieder korrekt
 *
 *Revision 1.62  2002/07/07 01:15:50  ms
 *-- aktOV wird jetzt im SenseObject gesetzt
 *
 *Revision 1.61  2002/07/06 23:28:07  ms
 *- uups (enemy.setX war leer)
 *
 *Revision 1.60  2002/07/06 23:08:50  ms
 *- Timestep wird gesetzt
 *
 *Revision 1.59  2002/07/06 22:02:27  ms
 *- TorPos wird jetzt dynamisch gesetzt
 *- Falls ein Spieler nicht gesehn wird, wird nur
 *  noch die folgen 5 Runden im Gedaechtnis nachgeschaur
 *- weitere Kommentare eingefgt
 *- sonst keine Ahnung mehr, was geaendert wurde
 *
 *Revision 1.58  2002/07/06 20:37:11  ms
 *- mit headangle
 *
 *Revision 1.57  2002/07/06 17:28:19  ms
 *-Spielernummer wird im OV gesetzt
 *
 *Revision 1.56  2002/07/06 16:15:35  ms
 *- neues XyzObject frn Ball wird angelegt
 *
 *Revision 1.55  2002/07/06 15:00:36  ms
 *- seeBall und BallWinkel wird wieder gesetzt
 *
 *Revision 1.54  2002/07/06 14:39:32  fg
 *auch SenseObject setzt isNewWO auf false
 *
 *Revision 1.53  2002/07/06 14:28:15  ms
 **** empty log message ***
 *
 *Revision 1.52  2002/07/06 01:11:14  js
 *Flagwerte verbessert
 *
 *Revision 1.51  2002/07/06 00:58:30  js
 *geringste Flag-Methode entbuggt...
 *
 *Revision 1.50  2002/07/06 00:53:55  pg
 *a und b in ballPos
 *
 *Revision 1.49  2002/07/06 00:32:56  js
 *PosBerechnung wird ist jetzt flexibler:
 *man kann jetzt einen Mittelwert von X Flags berechnen!
 *
 *Revision 1.48  2002/07/06 00:06:15  ms
 *- BallWinkel wird ins OV gesetzt
 *
 *Revision 1.47  2002/07/05 23:07:27  ms
 *- seeBall wurde nicht mehr auf false gesetzt (is korrigiert)
 *
 *Revision 1.46  2002/07/05 22:46:37  pg
 *getSeeBall laut schumi implementiert
 *
 *Revision 1.45  2002/07/05 19:45:17  js
 *Positionsberechnung jetzt anhand mehrerer Flags (schnitt)
 *
 *Revision 1.44  2002/07/05 17:49:51  ms
 *- nur Kommentare
 *
* Revision 1.38  2002/07/03 10:19:45  fg
 * Eibinden des Gedaechtnis
 *
 * Revision 1.37  2002/07/02 19:20:34  ms
 * - Performance des Weltbildes verbessert :-)
 *   Systemauslastung (bei mir) um 15% weniger
 *
 * Revision 1.36  2002/07/01 18:36:58  ms
 * - uups, da war ja noch ein Fehler
 *
 * Revision 1.35  2002/07/01 15:39:38  ms
 * - get1PlayerPos, enemypos,unknownPos,... berarbeitet
 * - Hear Nachricht wird ins OV geschrieben
 * - ebenso der aktuelle Spielmodus
 *
 * Revision 1.34  2002/07/01 13:38:39  ms
 * - noch nen Fehler in den FlagPos gefunden
 *
 * Revision 1.33  2002/06/30 22:44:28  ms
 * - kleine nderungen hier und da gettigt
 * - Gegner mssten jetzt gesehen werden und nicht mehr
 *    auf der selben Stelle wie der Spieler selbst stehen
 *
 * Revision 1.32  2002/06/30 21:50:58  ms
 * - Positionsberechnungen drften nun abgesehen von gewissen
 *   Abweichungen (bis zu 30cm) stimmen
 *
 * Revision 1.31  2002/06/28 14:11:54  sg
 * Testausgabe deaktiviert
 *
 * Revision 1.30  2002/06/27 11:27:07  ms
 *  - SelfPos berarbeitet
 * - Flag-Positionen korrigiert (Tor Positionen waren falsch gesetzt)
 *
 * Revision 1.28  2002/06/26 10:12:15  fg
 * *** empty log message ***
 *
 * Revision 1.27  2002/06/26 10:07:54  pg
 * playerPos geandert
 *
 * Revision 1.26  2002/06/26 09:52:47  pg
 * laut ms was geaendert
 *
 * Revision 1.25  2002/06/25 20:39:29  fg
 * Tore sind jetzt nichmehr an Position 2000 sondern an 70, was meinem Verstndnis nach Standardposition ist. Muss trotzdem irgendwann mal flexibel gemacht werden.
 *
 * Revision 1.24  2002/06/25 16:23:34  ms
 * - Bestimmung der Ballposition korrigiert
 *    es gibt nur noch eine geringe Abweichung von ca.0,5%,
 *    wird aber hoffentlich noch zu 0 % Fehlerquote
 *
 * Revision 1.23  2002/06/25 08:52:13  js
 * Diese Interesannte Testausgabe entfernt!
 *
 * Revision 1.22  2002/06/24 09:59:04  ms
 * - Bestimmung der SelfPos berarbeitet(allerdings war der Jens etwas schneller :-(
 *
 * Revision 1.21  2002/06/19 10:14:28  js
 * Wiedermal 0-Byte-Fehler
 *
 * Revision 1.19  2002/06/19 09:03:59  js
 * Flag 2 korrekt hinzugefuegt
 *
 * Revision 1.18  2002/06/18 22:51:16  ms
 * - Fehler bzgl. des Flagarrays gefunden und korrigiert
 *
 * Revision 1.17  2002/06/18 22:21:41  ms
 * - Abfrage, ob Sense oder SeeObject
 *
 * Revision 1.16  2002/06/17 19:53:59  fg
 * History-Format "aufgerumt" :)
 *
 * Revision 1.15  2002/06/17 19:51:50  fg
 * - Thread.yield() wurde durch Thread.sleep(5) mit Interrupt-handling ersetzt.
 *
 * Revision 1.14  2002/06/17 15:26:10  ms
 * - bergabe des OV an den Player eingebunden
 * - kleinen Fehler in der Formel korrigiert
 *
 * Revision 1.13  2002/06/17 14:49:07  js
 * Weltbild OHNE NullPointerExc. compilierbar gemacht!
 * eingehendes WorldObject wird jetzt in einer Temp-Variable gespeichert!
 * Abfrage in den Positionsberechnungen, ob die Spieler ueberhaupt gesehen werden (daher kamen die NullPointers)
 * Diverse kleine Bugfixes...
 *
 * Revision 1.12  2002/06/16 22:00:42  ms
 * - aus welchen Grnden auch immer stand der Quellcode uaf einmal doppelt drin
 *   (wurde hiermit entfernt)
 *
 * Revision 1.11  2002/06/16 15:19:05  ms
 * - Weltbild so verndert, dass es als Thread luft (hoffe ich jedenfalls)
 * - einzelne Kommentare noch eingefgt
 * - ^M herausgenommen (hoffe es lsst sich jetzt mit jedem Editor anstndig lesen)
 *   unter Linux im KWrite luft es jedenfalls einwandfrei
 *
 * Revision 1.10  2002/06/13 14:59:37  ms
 * - Methode aktualisieren erweitert, plus hier und da ein paar
 *    Kleinigkeiten
 *
 * Revision 1.9  2002/06/12 10:47:59  pg
 * try this
 *
 * Revision 1.8  2002/06/12 10:14:45  ms
 * - berechneSelfPos minimal geaendert.
 *
 * Revision 1.7  2002/06/12 09:59:35  ms
 * referenz auf seeObj geaendert
 *
 * Revision 1.6  2002/06/11 19:44:40  ms
 * *** empty log message ***
 *
 * Revision 1.5  2002/06/11 18:31:47  ms
 * *** empty log message ***
 *
 * Revision 1.4  2002/06/11 16:45:58  ms
 * *** empty log message ***
 *
 * Revision 1.3  2002/06/11 15:02:49  ms
 * - einzelne Positions-Berechnungen hinzugefgt
 * - desweiteren die Methoden berechnePosX und berechnePosY
 *    hinzugefgt
 *
 * Revision 1.2  2002/06/10 19:12:03  ms
 * -absolute Positionen der Flags
 *
 * Revision 1.1.1.1  2002/06/05 10:38:57  pg
 * intital version
 *
 *
 */
