/*
 * $Id: XyObject.java,v 1.5 2002/07/08 04:10:26 pg Exp $
 *
 */
/**
 * Objektklasse.
 * wird zur speicherung zweidimensionaler koordinaten verwendet.
 * @author Patrick Gaertner (pg)
 *
 */ 
public class XyObject
{	
	// Attribute
	/** X-koordinate im absoluten Koordinatensystem */
	private int x = 4444; // "4444" ist eine Teaminterne konvention fuer leere Koordinaten.
	/** Y-koordinate im absoluten Koordinatensystem */
	private int y = 4444;
	// Konstruktoren
	/** Standartkonstruktor ohne Parameter
	 * @author pg
	 */
	public XyObject()
	{
	}

	/** Konstruktor mit Koordinaten als Parametern
	 * @author pg
	 * @param xin X-koordinate
	 * @param yin Y-koordinate
	 */
	public XyObject(int xin, int yin)
	{
		this.x = xin;
		this.y = yin;
	}
	
	// get & set Methoden
	/** gibt die X-koordinate zurueck
	 * @author pg
	 * @return x die X-koordinate
	 */
	public int getX()
	{
		return this.x;
	}

	/** gibt die Y-koordinate zurueck
	 * @author pg
	 * @return y die Y-koordinate
	 */
	public int getY()
	{
		return this.y;
	}
	
	/** setzt die X-koordinate auf (xin)
	 * @author pg
	 * @param xin wert fuer zuweisung der koordinate
	 */
	public void setX(int xin)
	{
		this.x = xin;
	}

	/** setzt die Y-koordinate auf (yin)
	 * @author pg
	 * @param yin wert fuer zuweisung der koordinate
	 */
	public void setY(int yin)
	{
		this.y = yin;
	}
	
}

/*
 * $Log: XyObject.java,v $
 * Revision 1.5  2002/07/08 04:10:26  pg
 * seltsame leerzeichen entfernt, final version
 *
 * Revision 1.4  2002/06/17 10:37:26  pg
 * javaDoc komplett
 *
 * Revision 1.3  2002/06/12 10:51:06  pg
 * - standartkonstruktor
 *
 * Revision 1.2  2002/06/12 09:48:55  pg
 * - default der ints auf "4444" fuer "nix"
 *
 * Revision 1.1.1.1  2002/06/05 10:38:57  pg
 * intital version
 *
 *
 */
