/*
 * $Id: XyzObject.java,v 1.6 2002/07/08 04:08:23 pg Exp $
 *
 */
/**
 * Objektklasse.
 * wird zur speicherung von vektoren verwendet, um bewegte objekte zu beschreiben.
 * @author Patrick Gaertner (pg)
 *
 */

public class XyzObject
	extends XyObject
{
	// Attribute
	/** distanz zum Objekt*/
	private int a = 4444;
	/** winkel zum Objekt */
	private int b = 4444;
	
	// Konstruktoren
	/** Standartkonstruktor ohne Parameter
	 * @author pg
	 */
    public XyzObject()
	{
	}
	/** Konstruktor mit allen Koordinaten als Parametern
	 * @author pg
	 * @param xin X-koordinate, die an den Superklassenkonstruktor weitergereicht wird
	 * @param yin Y-koordinate, die an den Superklassenkonstruktor weitergereicht wird
	 * @param ain Distanz
	 * @param bin Winkel
	 */
	public XyzObject(int xin, int yin, int ain, int bin)
	{
        /** aufruf des superklassenkonstruktors */
		super((xin), (yin));
		this.a = ain;
		this.b = bin;
	}
	// get & set Methoden
	/** gibt die Distanz
	 * @author pg
	 * @return a die Distanz
	 */
	public int getA()
	{
		return this.a;
	}
	/** gibt der Winkel
	 * @author pg
	 * @return b der Winkel
	 */
	public int getB()
	{
		return this.b;
	}
	/** setzt die Distanz auf (ain)
	 * @author pg
	 * @param ain wert fuer die zuweisung der Distanz
	 */
	public void setA(int ain)
	{
		this.a = ain;
	}
	/** setzt den Winkel auf (bin)
	 * @author pg
	 * @param bin wert fuer die Zuweisung des Winkels
	 */
	public void setB(int bin)
	{
		this.b = bin;
	}
}

/*
 * $Log: XyzObject.java,v $
 * Revision 1.6  2002/07/08 04:08:23  pg
 * seltsame leerzeichen entfernt, final version
 *
 * Revision 1.5  2002/07/05 20:45:55  pg
 * a und b zurechtgewiesen ;)
 *
 * Revision 1.4  2002/06/17 10:37:14  pg
 * javaDoc komplett.
 *
 * Revision 1.3  2002/06/12 11:13:28  pg
 * standartkonstruktor
 *
 * Revision 1.2  2002/06/12 09:49:19  pg
 * - default der ints auf "4444" fuer "nix"
 *
 * Revision 1.1.1.1  2002/06/05 10:38:57  pg
 * intital version
 *
 *
 */
