/*
 * $Id: Taktik.java,v 1.114 2002/07/14 21:36:04 sg Exp $
 *
 */


package strategie;


import Player;
import OverviewObject;
import java.io.*;
import XyObject;
import XyzObject;
import Torwart;
//import java.lang.Math;

/**
  * TaktikKlasse.
  * interpretiert das OverviewObject und erstellt taktische Analyse.
  * @author Stefan Graber (sg)
  * @author Tobias Mller (tm)
  */

public class Taktik extends Thread
{

    /** Referenzen */

	/** aktueller Spieler */
    Player play;

	/** aktuelles OverviewObject */
	private OverviewObject aktOV;
	/** Variable zum temporren speichern des aktuellen OverviewObjects */
	private OverviewObject temp;
	private boolean sleepMode = false;

    /** Attribute */

	/** aktueller spielmodus */
	String spielmodus = ("before_kick_off");

	/** die verschiedenen Playmodes */
	String playOn 		= ("play_on");
	String beforeKickOff = ("before_kick_off");
	String kickOffL     = ("kick_off_l");
	String kickOffR     = ("kick_off_r");
	String kickInL      = ("kick_in_l");
	String kickInR      = ("kick_in_r");
	String cornerKickL  = ("corner_kick_l");
	String cornerKickR  = ("corner_kick_r");
	String goalKickL    = ("goal_kick_l");
	String goalKickR    = ("goal_kick_r");
	String afterGoalL   = ("goal_l");
	String afterGoalR   = ("goal_r");
	String offSideL     = ("offside_l");
	String offSideR     = ("offside_r");
	String freeKickL    = ("free_kick_l");
	String freeKickR    = ("free_kick_r");

	char SpielrichtungL = ('l');

	/** Die eigene Position */
	private int SelfPosX = 0;
	private int SelfPosY = 0;

	/** Die Pos des Balls */
	private int BallPosX= 0;
	private int BallPosY = 0;

    /** Die BallPosXY und XYZ */
    private XyObject BallPosXY = new XyObject(0,0);
    private XyzObject BallPosXYZ = new XyzObject(0, 0, 0, 0);


    /** Entfernung Ball - Spieler */
    private int ballDistance = 0;


	/** Timer fr myJob() */
	private int myJob =0;
	int move =1;

    /** StaminaProb Abfrage */
    private int staminaProb = 0;

    /** Feld mit Werten des Arcuscosinus */
    private int[] arccosArray = new int[2001];
    private double[] sin = new double[361];
    private double[] cos = new double[361];

    /** Konstruktor */

    public Taktik(Player playIn)
    {
        this.play = playIn;
        setArccos();
        for (int i=0; i<=360;i++)
        {
           sin[i] = Math.sin(Math.toRadians(i));
           cos[i] = Math.cos(Math.toRadians(i));
        }
    }

    /** get & set Methoden */

    public boolean setOV(OverviewObject akt)
    {
		this.temp = akt;
		return sleepMode;
	}

    public Player getPlay()
    {
    	return this.play;
	}

	private void getOV()
	{
		aktOV = this.temp;
		this.temp = null;
	}

  /** Fllt das arccos-Array mit Werten
   *  @author fg
   *  @see arccos(double x)
   */
 	private void setArccos()
  {
    double x;
    for (int i=0; i<=2000; i++)
    {
       x = ((double)i / 1000) - 1;
       arccosArray[i] = (int)Math.round(Math.toDegrees(Math.acos(x)));
    }
  }

	/** Methode run - Hauptprogramm
 	  * Mit der Runmethode wird eine Endlosschleife gestartet,  die immer ein neues aktuelles OVObject
	  * holt und es zur Berechnung an die Methode Spielzug() bergibt. Diese berrechnet die Reaktion
	  * des Spieles darauf. Auch wird hier schon die aktuelle Pos des Balls berechnet, damit nicht
	  * jede Methode diese neu errechnen muss.
	  * @author sg
	  * @author tm
	  */
	public void run()
	{
    	play.setTaktikThread(currentThread());

		while (true)
		{
			while (temp == null)
			{
		  		//gibt Rechenzeit frei
	      		// Thread.yield();
	        	try
	        	{
	        	  sleepMode = true;
	        	  currentThread().sleep(5);
	        	}
	        	catch (InterruptedException e)
	        	{
	        	}
         	  	sleepMode = false;
			}
			getOV();
			if (this.staminaProb == 1)
			{
				if(aktOV.getStamina() >= 2000)
				{
					this.staminaProb = 0;
					BallPosX = aktOV.getBallPos().getX();
					BallPosY = aktOV.getBallPos().getY();
					String Playmode = play.getSpielmodus();
					getPlaymode(Playmode);
				}
				//Stamina ist noch kleiner als 2000
				else
				{
					;//Warte noch
				}
			}
			else
			{
				BallPosX = aktOV.getBallPos().getX();
				BallPosY = aktOV.getBallPos().getY();
				//berprfe den spielmodus
				String Playmode = play.getSpielmodus();
				getPlaymode(Playmode);
			}


		}
	}


   /* Die Endlos-Schleife run() ruft immer wenn ein neues OVObject da ist, die Methode auf,
	* die dann das Verhalten der Spieler berechnet.
	*
	* Da wir ein 4-3-3 System spielen, werden die Spielernummern folgendermaen mit ihrer Pos verknpft:
	*  1 - Torwart
	*  2 - RAV
	*  3 - LIB
	*  4 - LAV
	*  5 - RM
	*  6 - RIM
	*  7 - LIM
	*  8 - LM
	*  9 - LA
	* 10 - MS
	* 11 - RA
	*/



	/** Methode getPlaymode
	  * Bestimmt wie sich die Spieler in bestimmten Spielsituationen (Freistoss, Kickoff)
	  * verhalten sollen.
	  * @author sg
	  * @author tm
	  * @param spielmodus
	  */

	public void getPlaymode(String spielmodus)
	{

		//Lege ein XyObject und XyzObject mit der aktuellen BallPos an
		BallPosXY = new XyObject(BallPosX,BallPosY);
		BallPosXYZ = aktOV.getBallPos();

		int spnr = play.getSpielernummer();

		//Ich spiel von rechts nach links
		if(play.getSpielrichtung() == 'l')
		{
			//wenn Spielfreigegeben, dann Spiel
			if (playOn.equals(spielmodus))
			{
			    if(play.getGoalieFree())
			    {
					play.setGoalieFree();
				}
			    spielzug(spnr);
			}
			//Wenn wir einen FreeKick bekommen
			else if (freeKickL.equals(spielmodus))
			{
				if (play.getGoalieFree())
				{
					if(spnr == 1)
					{
						if (aktOV.getSelfPos().getY() >= 0)
						{
							if (move == 0)
							{
								play.kick(new XyObject(200, 0), 300);
								this.move = 1;
							}
							else
							{
								play.move(new XyObject(-400, 170));
								this.move = 0;
							}
						}
						else
						{
							if (move == 0)
							{
								play.kick(new XyObject(200, 0), 300);
								this.move = 1;
							}
							else
							{
								play.move(new XyObject(-400, -170));
								this.move = 0;
							}
						}
					}
					else
					{
						BallPosX = 0;
						BallPosXY = new XyObject(BallPosX,BallPosY);
						findPos(spnr);
					}


				}
				else spielzug(spnr);
			}
			else if (freeKickR.equals(spielmodus))
			{
				if (BallPosX == 4444) play.turn(45);
				else if (spnr == 1) findPos(spnr);
				else
				{
					if (BallPosX >= -220)
					{
						BallPosX = BallPosX - 200;
						BallPosXY = new XyObject(BallPosX,BallPosY);
						findPos(spnr);
					}
					else
					{
						BallPosX = -510;
						BallPosXY = new XyObject(BallPosX,BallPosY);
						findPos(spnr);
					}
				}
			}
			//Vorm Anstoss - nehme Aufstellung ein
			else if (beforeKickOff.equals(spielmodus))
			{
				play.getAufstellungMitBall(spnr);
			}
			//Nach einem Tor, nehme Aufstellung ein
			else if (afterGoalL.equals(spielmodus))
			{
				play.getAufstellungOhneBall(spnr);
				play.adjust(new XyObject(0,0));
			}
			//Nach einen Gegentor, nehme Aufstellung ein
			else if (afterGoalR.equals(spielmodus))
			{
				play.getAufstellungMitBall(spnr);
				play.adjust(new XyObject(0,0));
			}
			//Wenn wir Anstoss haben, fhre Anstoss durch
			else if (kickOffL.equals(spielmodus))
			{
				spielzug(spnr);
			}
			//Wenn der Gegner Anstoss hat, fang an zu spielen
			else if (kickOffR.equals(spielmodus))
			{
				play.adjust(new XyObject(0,0));
			}
			else if (kickInL.equals(spielmodus))
			{
				spielzug(spnr);
			}
			else if (kickInR.equals(spielmodus))
			{
				findPos(spnr);
			}
			else if (cornerKickL.equals(spielmodus))
			{
				spielzug(spnr);
			}
			else if (cornerKickR.equals(spielmodus))
			{
				BallPosX = -510;
				BallPosXY = new XyObject(BallPosX,BallPosY);
				findPos(spnr);
			}
			else if (goalKickL.equals(spielmodus))
			{
				 if(spnr == 1)
				 {
					 spielzug(spnr);
				 }
				 else
				 {
					 BallPosX = 0;
					 BallPosXY = new XyObject(BallPosX,BallPosY);
					 findPos(spnr);
				 }
			}
			else if (goalKickR.equals(spielmodus))
			{
				BallPosX = BallPosX - 300;
				BallPosXY = new XyObject(BallPosX,BallPosY);
				findPos(spnr);
			}
			else if (offSideL.equals(spielmodus))
			{
				BallPosX = BallPosX - 200;
				BallPosXY = new XyObject(BallPosX,BallPosY);
				findPos(spnr);
			}
			else if (offSideR.equals(spielmodus))
			{
				BallPosX = BallPosX + 200;
				BallPosXY = new XyObject(BallPosX,BallPosY);
				findPos(spnr);
			}
			else //Default
			{
				spielzug(spnr);
			}
		}
		else if(play.getSpielrichtung() == 'r')
		{
			//Ich spiel von rechts nach links

			//wenn Spielfreigegeben, dann Spiel
			if (playOn.equals(spielmodus))
			{
			    if(play.getGoalieFree())
				{
					play.setGoalieFree();
				}
			    spielzug(spnr);
			}
			else if (freeKickR.equals(spielmodus))
			{
				if (play.getGoalieFree())
				{
					if(spnr == 1)
					{
						if (aktOV.getSelfPos().getY() >= 0)
						{
							if (move == 0)
							{
								play.kick(new XyObject(200, 170), 300);
								this.move = 1;
							}
							else
							{
								play.move(new XyObject(-400, 0));
								this.move = 0;
							}
						}
						else
						{
							if (move == 0)
							{
								play.kick(new XyObject(200, -170), 300);
								this.move = 1;
							}
							else
							{
								play.move(new XyObject(-400, 0));
								this.move = 0;
							}
						}
					}
					else
					{
						BallPosX = 0;
						BallPosXY = new XyObject(BallPosX,BallPosY);
						findPos(spnr);
					}
				}
				else spielzug(spnr);
			}
			else if (freeKickL.equals(spielmodus))
			{
				if (BallPosX == 4444) play.turn(45);
				else if (spnr == 1) findPos(spnr);
				else
				{
					if (BallPosX >= -220)
					{
						BallPosX = BallPosX - 200;
						BallPosXY = new XyObject(BallPosX,BallPosY);
						findPos(spnr);
					}
					else
					{
						BallPosX = -510;
						BallPosXY = new XyObject(BallPosX,BallPosY);
						findPos(spnr);
					}
				}
			}
			//Vorm Anstoss - nehme Aufstellung ein
			else if (beforeKickOff.equals(spielmodus))
			{
				play.getAufstellungMitBall(spnr);
			}
			//Nach einem Gegentor, nehme Aufstellung ein
			else if (afterGoalL.equals(spielmodus))
			{
				play.getAufstellungMitBall(spnr);
				play.adjust(new XyObject(0,0));
			}
			//Nach einen Tor, nehme Aufstellung ein
			else if (afterGoalR.equals(spielmodus))
			{
				play.getAufstellungOhneBall(spnr);
				play.adjust(new XyObject(0,0));
			}
			//Wenn wir Anstoss haben, fhre Anstoss durch
			else if (kickOffR.equals(spielmodus))
			{
				spielzug(spnr);
			}
			//Wenn der Gegner Anstoss hat, fang an zu spielen
			else if (kickOffL.equals(spielmodus))
			{
				play.adjust(new XyObject(0,0));
			}
			else if (kickInL.equals(spielmodus))
			{
			   findPos(spnr);
			}
			else if (kickInR.equals(spielmodus))
			{
				spielzug(spnr);
			}
			else if (cornerKickL.equals(spielmodus))
			{
				BallPosX = -510;
				BallPosXY = new XyObject(BallPosX,BallPosY);
				findPos(spnr);
			}
			else if (cornerKickR.equals(spielmodus))
			{
				spielzug(spnr);
			}
			else if (goalKickL.equals(spielmodus))
			{
				BallPosX = BallPosX - 300;
				BallPosXY = new XyObject(BallPosX,BallPosY);
				findPos(spnr);
			}
			else if (goalKickR.equals(spielmodus))
			{

				if(spnr == 1)
				{
					spielzug(spnr);
				}
				else
				{
					BallPosX = 0;
					BallPosXY = new XyObject(BallPosX,BallPosY);
					findPos(spnr);
				}
			}
			else if (offSideL.equals(spielmodus))
			{
				BallPosX = BallPosX + 200;
				BallPosXY = new XyObject(BallPosX,BallPosY);
				findPos(spnr);
			}
			else if (offSideR.equals(spielmodus))
			{
				BallPosX = BallPosX - 200;
				BallPosXY = new XyObject(BallPosX,BallPosY);
				findPos(spnr);
			}
			else //Default
			{
				spielzug(spnr);
			}
		}
		else System.out.println("Fehlerhafte Spielrichtung vom Server empfangen!");
	}

	/** Methode Spielzug
	  * ruft fr jeden Spieler seine Methode auf
	  * Anhand seiner Spielernummer und des AktOV trifft jeder Spieler eine Entscheidung
	  * Verzweigt je ob BallPos bekannt ist oder nicht.
	  * @author sg
	  * @author tm
	  * @param aktOV - aktuelles OverviewObject
	  */

	public void spielzug(int Spielernummer)
	{
		int spnr = Spielernummer;

		//Schaue ob Du weit, wo Du Dich befindest
		if (aktOV.getSelfPos().getX()==4444)
		{
			//Dreh dich
			play.turn(45);
		}

		else if (aktOV.getStamina() <= 200)
		{
			staminaProb = 1;
		}

    	else if (spnr == 1)
    	{
			Torwart torwart = (Torwart)play;

			if (aktOV.getSeeBall())
			{
				play.shout(BallPosXYZ, 12, new XyObject(0,0));
			}
			if (BallPosX == 4444)
			{
				if(SelfPosY >= 0)
				{
					//nach rechts drehen
					play.turn(45);
				}
				else play.turn(-45);
			}
			//Nun handle als Keeper nach Situation
			else if (catchArea())
				torwart.catchBall(aktOV.getBallWinkel());
				else if (PlayArea())
					{
						if (aktOV.get1PlayerPos(5).getX() != 4444)
						{
							int a11 = aktOV.get1PlayerPos(5).getX()+100;
							int b11 = aktOV.get1PlayerPos(5).getY();
							play.kick(new XyObject(a11, b11));
						}
						else if (aktOV.get1PlayerPos(8).getX() != 4444)
						{
							int a12 = aktOV.get1PlayerPos(8).getX()+100;
							int b12 = aktOV.get1PlayerPos(8).getY();
							play.kick(new XyObject(a12, b12));
						}
						else play.kick(new XyObject(200, 50), 100);
					}
					//Wenn der Ball nher als 200 ist
					else
					{
						if (ballDistance() < 150 && BallPosXYZ.getA() <= 2 && BallPosXYZ.getA() >= -15)
							play.moveTo(getFutureBall(derPos()), 100);
						else
							findPos(spnr);
					}
		}


		//Du bist ein "normaler" Spieler
		else
		{
			//Spieler sieht den Ball nicht
			if (BallPosX == 4444)
			{
				if(SelfPosY >= 0)
				{
					//nach rechts drehen
					play.turn(45);
				}
				else play.turn(-45);
			}
			//Spieler sieht den Ball
			else
			{
				if (aktOV.getSeeBall())
				{
					  //Brlle die aktuelle Pos des Balls rum..
					  play.shout(BallPosXYZ, 12, new XyObject(0,0));
	     	    }
				//Schaue ob der Ball im Spielbaren Bereich ist.
				if (PlayArea())
				{
					//Versuch eines Torschusses oder Pass
				 	torschuss(spnr);
				}
				//Schaue ob der Ball nicht weiter als x Meter weg ist.
				else if (myJob(spnr))
				     {
					 	 //geh auf den Ball.
						 play.moveTo(getFutureBall(derPos()), 100);
				 	 }
					 //Schaue ob Ball in meinem Bereich ist
					 else if (MyArea(spnr))
						 {
							  if(BallPosXYZ.getA() <= -25)
							  	  play.moveTo(new XyObject(SelfPosX - 100, SelfPosY), 100);
					  	      //geh auf den Ball.
							  else play.moveTo(getFutureBall(derPos()), 100);
						  }
						  //Nehme vorgeschriebene Pos zum Ball ein
						  else
						  {
				   			   findPos(spnr);
		    		  	  }
			}
		}
	}

	/** Methode PlayArea
	  * Nachdem die Methode Spielzug gestartet wurde und der Spieler den Ball sieht, wird zunchst
	  * die Methode PlayArea aufgerufen. Diese prft ob der Spieler den Ball spielen kann. Wenn der
	  * Anstand kleiner als 0.5 Meter ist, kann man ihn spielen, also liefert die Methode true zurck
	  * Sonst false.
	  * @auther sg
	  * @auther tm
	  * @returns true/false
	  */
	public boolean PlayArea()
	{
		this.ballDistance = ballDistance();

		if (ballDistance <= 4)
		{
			return true;
		}
		else return false;
	}

	/** Methode torschuss
	 *
	 * Schaue ob Position zum Tor gut ist, wenn true dann "Schu aufs Tor"
     * @auther sg
	 * @param spnr - Spielernummer
	 */

	public void torschuss(int spnr)
	{
		if(SelfPosX >= 380)
		{
			if(Math.abs(SelfPosX) + (Math.abs(SelfPosY)) >= 600)
			{
				pass(spnr);
			}
			else
			{
				if(SelfPosY >= 0)
				{
					play.kick(new XyObject(525, 50), 70);
				}
				else play.kick(new XyObject(525, -50), 70);
			}
		}
		else if(SelfPosX >= 200)
		{
			if(Math.abs(SelfPosX) + (Math.abs(SelfPosY)) >= 600)
			{
				pass(spnr);
			}
			else play.kick(new XyObject(525, 0), 100);
		}
		else pass(spnr);
	}

	/** Methode pass
	 * Passt zu Mitspielern oder in den Raum
	 * @auther sg
	 * @param spnr - Spielernummer
	 * @see torschuss
	 */
	public void pass(int spnr)
		{
			switch (spnr)
			{
				//Torwart
				case 1: break;
				//RV
				case 2: //Schaue ob Du den RA siehst.
						if (aktOV.get1PlayerPos(8).getX() != 4444)
						{
							int a21 = aktOV.get1PlayerPos(8).getX()+100;
							int b21 = aktOV.get1PlayerPos(8).getY();
							play.kick(new XyObject(a21, b21));
						}
						//Dann schaue ob Du den MS siehst
						else if (aktOV.get1PlayerPos(9).getX() != 4444)
						{
							int a22 = aktOV.get1PlayerPos(9).getX()+100;
							int b22 = aktOV.get1PlayerPos(9).getY();
							play.kick(new XyObject(a22, b22));
						}
						//Dann schaue ob Du den SM siehst
						else if (aktOV.get1PlayerPos(6).getX() != 4444)
						{
							int a23 = aktOV.get1PlayerPos(6).getX()+100;
							int b23 = aktOV.get1PlayerPos(6).getY();
							play.kick(new XyObject(a23, b23));
						}
						else
						//Standardpass
						play.kick(new XyObject(100,-100)); break;
				//LIB
				case 3: //Schaue ob Du den RA siehst.
						if (aktOV.get1PlayerPos(8).getX() != 4444)
						{
							int a31 = aktOV.get1PlayerPos(8).getX()+100;
							int b31 = aktOV.get1PlayerPos(8).getY();
							play.kick(new XyObject(a31, b31));
						}
						//Dann schaue ob Du den LA siehst
						else if (aktOV.get1PlayerPos(10).getX() != 4444)
						{
							int a32 = aktOV.get1PlayerPos(10).getX()+100;
							int b32 = aktOV.get1PlayerPos(10).getY();
							play.kick(new XyObject(a32, b32));
						}
						//Dann schaue ob Du den MS siehst
						else if (aktOV.get1PlayerPos(9).getX() != 4444)
						{
							int a33 = aktOV.get1PlayerPos(9).getX()+100;
							int b33 = aktOV.get1PlayerPos(9).getY();
							play.kick(new XyObject(a33, b33));
						}
						else
						//Standardpass
						{
							if (SelfPosY <= 0)
							{
								play.kick(new XyObject(100,-100));
							}
							else play.kick(new XyObject(100, 100));
						}
						break;
				//LV
				case 4: //Schaue ob Du den LA siehst.
						if (aktOV.get1PlayerPos(10).getX() != 4444)
						{
							int a41 = aktOV.get1PlayerPos(10).getX()+100;
							int b41 = aktOV.get1PlayerPos(10).getY();
							play.kick(new XyObject(a41, b41));
						}
						//Dann schaue ob Du den RA siehst
						else if (aktOV.get1PlayerPos(8).getX() != 4444)
						{
							int a42 = aktOV.get1PlayerPos(8).getX()+100;
							int b42 = aktOV.get1PlayerPos(8).getY();
							play.kick(new XyObject(a42, b42));
						}
						//Dann schaue ob Du den MS siehst
						else if (aktOV.get1PlayerPos(9).getX() != 4444)
						{
							int a43 = aktOV.get1PlayerPos(9).getX()+100;
							int b43 = aktOV.get1PlayerPos(9).getY();
							play.kick(new XyObject(a43, b43));
						}
						else
						//Standardpass
						play.kick(new XyObject(100,100)); break;
				//RM
				case 5: //Schaue ob Du den MS siehst.
						if (aktOV.get1PlayerPos(9).getX() != 4444)
						{
							int a51 = aktOV.get1PlayerPos(9).getX()+100;
							int b51 = aktOV.get1PlayerPos(9).getY();
							play.kick(new XyObject(a51, b51));
						}
						//Dann schaue ob Du den RA siehst
						else if (aktOV.get1PlayerPos(8).getX() != 4444)
						{
							int a52 = aktOV.get1PlayerPos(8).getX()+100;
							int b52 = aktOV.get1PlayerPos(8).getY();
							play.kick(new XyObject(a52, b52));
						}
						//Dann schaue ob Du den LA siehst
						else if (aktOV.get1PlayerPos(10).getX() != 4444)
						{
							int a53 = aktOV.get1PlayerPos(10).getX()+100;
							int b53 = aktOV.get1PlayerPos(10).getY();
							play.kick(new XyObject(a53, b53));
						}
						else
						//Standardpass
						play.kick(new XyObject(300,-160)); break;
				//RIM
				case 6: //Schaue ob Du den MS siehst.
						if (aktOV.get1PlayerPos(9).getX() != 4444)
						{
							int a61 = aktOV.get1PlayerPos(9).getX()+100;
							int b61 = aktOV.get1PlayerPos(9).getY();
							play.kick(new XyObject(a61, b61));
						}
						//Dann schaue ob Du den LA siehst
						else if (aktOV.get1PlayerPos(10).getX() != 4444)
						{
							int a62 = aktOV.get1PlayerPos(10).getX()+100;
							int b62 = aktOV.get1PlayerPos(10).getY();
							play.kick(new XyObject(a62, b62));
						}
						//Dann schaue ob Du den RA siehst
						else if (aktOV.get1PlayerPos(8).getX() != 4444)
						{
							int a63 = aktOV.get1PlayerPos(8).getX()+100;
							int b63 = aktOV.get1PlayerPos(8).getY();
							play.kick(new XyObject(a63, b63));
						}
						else
						//Standardpass
						play.kick(new XyObject(300,0)); break;
				//LIM
				case 7: //Schaue ob Du den MS siehst.
						if (aktOV.get1PlayerPos(9).getX() != 4444)
						{
							int a71 = aktOV.get1PlayerPos(9).getX()+100;
							int b71 = aktOV.get1PlayerPos(9).getY();
							play.kick(new XyObject(a71, b71));
						}
						//Dann schaue ob Du den LA siehst
						else if (aktOV.get1PlayerPos(10).getX() != 4444)
						{
							int a72 = aktOV.get1PlayerPos(10).getX()+100;
							int b72 = aktOV.get1PlayerPos(10).getY();
							play.kick(new XyObject(a72, b72));
						}
						//Dann schaue ob Du den RA siehst
						else if (aktOV.get1PlayerPos(8).getX() != 4444)
						{
							int a73 = aktOV.get1PlayerPos(8).getX()+100;
							int b73 = aktOV.get1PlayerPos(8).getY();
							play.kick(new XyObject(a73, b73));
						}
						else
						//Standardpass
						play.kick(new XyObject(300,0)); break;
				//LM
				case 8: //Schaue ob Du den MS siehst.
						if (aktOV.get1PlayerPos(9).getX() != 4444)
						{
							int a81 = aktOV.get1PlayerPos(9).getX()+100;
							int b81 = aktOV.get1PlayerPos(9).getY();
							play.kick(new XyObject(a81, b81));
						}
						//Dann schaue ob Du den LA siehst
						else if (aktOV.get1PlayerPos(10).getX() != 4444)
						{
							int a82 = aktOV.get1PlayerPos(10).getX()+100;
							int b82 = aktOV.get1PlayerPos(10).getY();
							play.kick(new XyObject(a82, b82));
						}
						//Dann schaue ob Du den RA siehst
						else if (aktOV.get1PlayerPos(8).getX() != 4444)
						{
							int a83 = aktOV.get1PlayerPos(8).getX()+100;
							int b83 = aktOV.get1PlayerPos(8).getY();
							play.kick(new XyObject(a83, b83));
						}
						else
						//Standardpass
						play.kick(new XyObject(250,160)); break;
				//Sturm. passt eh selten - sondern schiet eher aufs Tor
				case 9: XyObject pass9 = new XyObject(450, 0);
						play.kick(pass9); break;
				case 10:XyObject pass10 = new XyObject(450, 0);
						play.kick(pass10); break;
				case 11:XyObject pass11 = new XyObject(450, 0);
						play.kick(pass11); break;
			}
	}


	/** Methode MyArea
	  * prft, ob der Ball im "Bereich" des Spielers ist
	  * @author sg
	  * @author tm
	  * @param spnr - Spielernummer
	  * @return true/false
	  * @see spielzug
	  */

	public boolean MyArea(int spnr)
	{
		//Zur Berechnung die Ballpos holen
		int x = BallPosX;
		int y = BallPosY;


		switch(spnr)
		{
			// Torwart: 16m-Raum
			case  1: if ( (x >= -526) && (x <= -300) && (y >= -200) && (y <=  200) ) return true; break;
			//Abwehr
			case  2: if ( (x >= -530) && (x <= -50) && (y >= -340)  && (y <= -100) ) return true; break;
			case  3: if ( (x >= -530) && (x <= -50) && (y >= -120)  && (y <=  120) ) return true; break;
			case  4: if ( (x >= -530) && (x <= -50) && (y >=  100)  && (y <=  340) ) return true; break;
			//Mittelfeld
			case  5: if ( (x >= -200) && (x <=  200) && (y >= -340) && (y <= -160) ) return true; break;
			case  6: if ( (x >= -200) && (x <= 	200) && (y >= -160) && (y <=    0) ) return true; break;
			case  7: if ( (x >= -200) && (x <=  200) && (y >=    0) && (y <=  160) ) return true; break;
			case  8: if ( (x >= -200) && (x <=  200) && (y >=  160) && (y <=  340) ) return true; break;
			//Sturm
			case  9: if ( (x >=  100) && (x <=  600) && (y >= -340) && (y <= -100) ) return true; break;
			case 10: if ( (x >=  100) && (x <=  600) && (y >= -120) && (y <=  120) ) return true; break;
			case 11: if ( (x >=  100) && (x <=  600) && (y >=  100) && (y <=  340) ) return true; break;
		}
		return false;
	}

	/** Methode myJob
	 * prft ab, ob der Spieler nher als 5m zum Ball steht.
	 * @author tm
	 * @param spnr - Spielernummer
	 * @returns true/false
	 */
	public boolean myJob(int spnr)
	{
		if (ballDistance() < 50)
		{
			return true;
		}
		else return false;
	}


	/** Methode findPos
	  * bestimmt das Verhalten der Spieler, wenn der Ball nicht in ihrem "Bereich" ist
	  * @author sg
	  * @param spnr - Spielernummer
	  */

	public void findPos(int spnr)
	{
		switch (spnr)
		{
			//TW
			case 1: int temp = indenWeg();
					if (SelfPosX >= -510 && SelfPosX <= -490 && SelfPosY >= temp -10 && SelfPosY <= temp +10)
					{
						play.adjust(BallPosXY);
					}
					else play.moveTo(new XyObject(-500, temp), speed());
					break;

  			//RV
			case 2: if(BallPosX > -50)
					{
						if (SelfPosX >= -210 && SelfPosX <= -190 && SelfPosY >= -130 && SelfPosY <= -110)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(-200, -120), 70);
					}
					else if(BallPosY > -100)
					{
						if (SelfPosX >= BallPosX-30 && SelfPosX <= BallPosX-10  && SelfPosY >= -120 && SelfPosY <= -100)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(BallPosX-20, -110 ), 70);
					}
					else play.moveTo(new XyObject(BallPosX-50, BallPosY + 100), speed());
					break;
			//LIB
			case 3: if(BallPosX > -50)
					{
						if (SelfPosX >= -210 && SelfPosX <= -190 && SelfPosY >= -10 && SelfPosY <= 10)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(-200, 0), 70);
					}
					else if (BallPosY > 100)
					{
						if (SelfPosX >= BallPosX-30 && SelfPosX <= BallPosX-10  && SelfPosY >= 60 && SelfPosY <= 80)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(BallPosX-20, 70 ), 70);
					}
					else if (BallPosY < -100)
					{
						if (SelfPosX >= BallPosX-30 && SelfPosX <= BallPosX-10  && SelfPosY >= -80 && SelfPosY <= -60)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(BallPosX-20, -70 ), 70);
					}
					else play.moveTo((BallPosXY), speed());
					break;
			//LV
			case 4: if(BallPosX > -50)
					{
						if (SelfPosX >= -210 && SelfPosX <= -190  && SelfPosY >= 110 && SelfPosY <= 130)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(-200, 120), 70);
					}
					else if (BallPosY < 100)
					{
						if (SelfPosX >= BallPosX-30 && SelfPosX <= BallPosX-10  && SelfPosY >= 100 && SelfPosY <= 120)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(BallPosX, 110 ), 70);
					}
					else play.moveTo(new XyObject(BallPosX-50, BallPosY - 100), speed());
					break;
			//RM
			case 5: if(BallPosX > 200)
					{
						if (SelfPosX >= 140 && SelfPosX <= 160 && SelfPosY >= -250 && SelfPosY <= -230)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(150, -240), 70);
					}
					else if (BallPosX < -200)
					{
						if (SelfPosX >= -160 && SelfPosX <= -140 && SelfPosY >= -250 && SelfPosY <= -230)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(-150, -240), 70);
					}
					else if (BallPosY > -160)
					{
						if (SelfPosX >= BallPosX-10 && SelfPosX <= BallPosX+10  && SelfPosY >= -190 && SelfPosY <= -170)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(BallPosX, -180 ), 70);
					}
					else play.moveTo(new XyObject(BallPosX-50, BallPosY + 100), speed());
					break;
			//RIM
			case 6: if(BallPosX > 200)
					{
						if (SelfPosX >= 140 && SelfPosX <= 160 && SelfPosY >= -90 && SelfPosY <= -70)
						{
						play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject( 150, -80), 70);
					}
					else if (BallPosX < -200)
					{
						if (SelfPosX >= -160 && SelfPosX <= -140 && SelfPosY >= -90 && SelfPosY <= -70)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(-150, -80), 70);
					}
					else if (BallPosY < -160 || BallPosY > 0)
					{
						if (SelfPosX >= BallPosX-10 && SelfPosX <= BallPosX+10  && SelfPosY >= -90 && SelfPosY <= -70)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(BallPosX, -80), 70);
					}
					else play.moveTo(BallPosXY, speed());
					break;
			//LIM
			case 7: if(BallPosX > 200)
					{
						if (SelfPosX >= 140 && SelfPosX <= 160 && SelfPosY >= 70 && SelfPosY <= 90)
						{
						play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject( 150, 80), 70);
					}
					else if (BallPosX < -200)
					{
						if (SelfPosX >= -160 && SelfPosX <= -140 && SelfPosY >= 70 && SelfPosY <= 90)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(-150, 80), 70);
					}
					else if (BallPosY > 160 || BallPosY < 0)
					{
						if (SelfPosX >= BallPosX-10 && SelfPosX <= BallPosX+10  && SelfPosY >= 70 && SelfPosY <= 90)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(BallPosX, 80), 70);
					}
					else play.moveTo(BallPosXY, speed());
					break;
			//LM
			case 8: if(BallPosX > 200)
					{
						if (SelfPosX >= 140 && SelfPosX <= 160 && SelfPosY >= 230 && SelfPosY <= 250)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(150, 240), 70);
					}
					else if (BallPosX < -200)
					{
						if (SelfPosX >= -160 && SelfPosX <= -140 && SelfPosY >= 230 && SelfPosY <= 250)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(-150, -240), 70);
					}
					else if (BallPosY < 160)
					{
						if (SelfPosX >= BallPosX-10 && SelfPosX <= BallPosX+10  && SelfPosY >= 170 && SelfPosY <= 190)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(BallPosX, 180 ), 70);
					}
					else play.moveTo(new XyObject(BallPosX-50, BallPosY - 100), speed());
					break;
			//RA
			case 9: if(BallPosX < 100)
					{
						if (SelfPosX >= 140 && SelfPosX <= 160 && SelfPosY >= -170 && SelfPosY <= -150)
						{
							play.adjust(BallPosXY);
						}
						else
						{
							play.moveTo(new XyObject(150, -160), 70);
						}
					}
					else if (BallPosY > -100)
					{
						if (SelfPosX >= BallPosX-10 && SelfPosX <= BallPosX+10  && SelfPosY >= -170 && SelfPosY <= -150)
						{
							play.adjust(BallPosXY);
						}
						else
						{
							play.moveTo(new XyObject(BallPosX, -160 ), 70);
						}
					}
					else play.moveTo(new XyObject(BallPosX-50, BallPosY + 100), speed());
					break;
		   //MS
		   case 10: if(BallPosX < 100)
					{
						if (SelfPosX >= 140 && SelfPosX <= 160 && SelfPosY >= -10 && SelfPosY <= 10)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(150, 0), 70);
					}
					else if (BallPosY > 100 || BallPosY < -100)
					{
						if (SelfPosX >= BallPosX-10 && SelfPosX <= BallPosX+10  && SelfPosY >= -10 && SelfPosY <= 10)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(BallPosX, 0 ), 70);
					}
					else play.moveTo(new XyObject(BallPosX+50, BallPosY), speed());
					break;
		   //LA
		   case 11: if(BallPosX < 100)
					{
						if (SelfPosX >= 140 && SelfPosX <= 160 && SelfPosY >= 150 && SelfPosY <= 170)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(150, 160), 70);
					}
					else if (BallPosY < 100)
					{
						if (SelfPosX >= BallPosX-10 && SelfPosX <= BallPosX+10  && SelfPosY >= 150 && SelfPosY <= 170)
						{
							play.adjust(BallPosXY);
						}
						else play.moveTo(new XyObject(BallPosX, 160 ), 70);
					}
					//Sonst gehe auf den Ball
					else play.moveTo(new XyObject(BallPosX-50, BallPosY - 100), speed());
					break;
		}
	}

	 /** Nun Folgen Methoden zur Berechnung von Abstnden */


	/** Methode ballDistance
	  * bestimmt mittels Satz des Pytagoras den Abstand zwischen dem Ball und
	  * der Position des Spielers.
      * @author tm
      * @see PlayArea()
	  * @see myJob
      * @return Abstand zum Ball
      */
    public int ballDistance()
    {
    // aktuelle Ballposition (x1,y1)
    int x1 = BallPosX;
    int y1 = BallPosY;
    // eigene aktuelle Position (x2,y2)
    int x2 = aktOV.getSelfPos().getX();
    int y2 = aktOV.getSelfPos().getY();
	//Da diese Methode IMMER zuerst gestartet wird, wird die akt. SelfPos fr event. weiter
	//Berechnungen bergeben
	SelfPosX = x2;
	SelfPosY = y2;

    // Abstandsberechnung durch Satz des Pytagoras
    double x = (x1-x2)*(x1-x2);

    double y = (y1-y2)*(y1-y2);
    int tmp = (int)Math.sqrt(x+y);

    return tmp;
    }


	/** Methode xyDistance
 	  * bestimmt den Abstand zwischen einer (x,y)-Koordinate und der Pos des Spielers.
      * Wird fr die Berechnung der Berechnung der Schussstrke bentigt.
      * @author tm
      * @param a - x-Koordinate
      * @param b - y-Koordinate
      * @returns Abstand des Spielers zur (x,y)-Koordinate
      */
    public int xyDistance(int a, int b)
    {
    // eigene aktuelle Position (x2,y2)
    int x = SelfPosX;
    int y = SelfPosY;

    // Abstandsberechnung durch Satz des Pytagoras
    double a2 = (x-a)*(x-a);

    double b2 = (y-b)*(y-b);
    int c = (int)Math.sqrt(a2+b2);

    return c;
    }


	/** Methode distance
	  *  bestimmt den Abstand zwischen zweier (x,y)-Koordinaten
	  * @author tm
	  * @param a - 1. x-Koordinate
	  * @param b - 1. y-Koordinate
	  * @param c - 2. x-Koordinate
	  * @param d - 2- y-Koordinate
	  * @returns Abstand der beiden (x,y)-Koordinaten
      */
    public int distance(int a, int b, int c, int d)
    {
    // Abstandsberechnung durch Satz des Pytagoras
    double x = (a-c)*(a-c);
    double y = (b-d)*(b-d);
    int tmp = (int)Math.sqrt(x+x);

    return tmp;
    }

  /** Methode speed()
    *
    * Berechnet die Geschwindigkeit in abh. zur Entfernung zum Ball
    * @author tm
    * @author sg
    * @see balldistance
    * @return int (speed)
    */
  public double speed()
  {
	  int speed = ballDistance();
	  if (speed <= 20)
	  	return 40;
	  else return 100;
  }

  /** Berechnet in abh. der Distanz, welches XyObject der BallPos in X Ticks berechnet wird
	* @author sg
	* @return int, in wieviel Ticks das Xy brechnet werden soll.
	*/
  public int derPos()
  {
	  /**
	  if(aktOV.getBallPos().getA() >= 20)
	  {
		  this.moveBlind = 1;
		  return 1;
	  }
	  else return 0;
	  */
	  return 1;
  }

  /** Schlgt den Arcus-Cosinus in einer Tabelle nach und liefert den zugehrigen Winkel im Gradmass zurck
   *  @author fg
   *  @param x Double zwischen -1 und 1 von dem der arccos ausgerechnet werdne soll.
   *  @return ArcusCosiuns von x oder 4444 wenn x nicht im bereich von -1 bis 1
   */
  private int arccos(double x)
  {
    if (x < -1 || x > 1) return 4444;
    int pos = (int)((x + 1) * 1000);
    return arccosArray[pos];
  }

  /** Funktion berechnet wo der Ball in runden Runden liegt, falls er sich
   *  in gleiche Richtung und gleicher Geschwindigkeit fortbewegt
   *  @author fg
   *  @param runden Anzahl der Runden fr die die Ballposition berechnet werden soll.
   *  @return Ballposition in (runden) Runden, als XyObject
   *  @see XyObject
   */
  private XyObject getFutureBall(int runden)
  {
    XyzObject ballPos = aktOV.getBallPos();
    if (ballPos.getA() == 4444 || ballPos.getB() == 4444)
    	return ballPos;
   /* int deltaX = (int)Math.round(sin[(ballPos.getB() + 90) % 360] * ballPos.getA());
    int deltaY = (int)Math.round(cos[(ballPos.getB() + 90) % 360] * ballPos.getA());*/
    return new XyObject(ballPos.getX()+ballPos.getA()*runden, ballPos.getY()+ballPos.getB()*runden);

  }

   /**
    *
    * @author fg
    * @param ball - beliebiges XyzObject
    * @param xKoord - x-Koordinate
    * @return XyObject - Schnittpunkt
    */
  public XyObject schnitt(XyzObject ball, int xKoord)
  {
   if (ball.getA() == 0) return null;
    double faktor = Math.abs((double)(ball.getX() - xKoord)) / ball.getA();
    if (xKoord < ball.getX())
    {
      if (faktor < 0)
        return new XyObject(xKoord, (int)(ball.getY()+faktor*ball.getB()));
      else
        return null;
    }
    if (xKoord > ball.getX())
    {
      if (faktor > 0)
        return new XyObject(xKoord, (int)(ball.getY()+faktor*ball.getB()));
      else
        return null;
    }
    if (xKoord == ball.getX()) return ball;
    return null;
  }

	public int indenWeg()
	{
		int winkel = getWinkel(new XyObject(-526, 0), BallPosXY);
		if (winkel >= 270)
		{
			winkel = 360-winkel;
			if (winkel >= 0 && winkel <= 5 )
				return 0;
			else if (winkel >= 5 && winkel < 10 )
				return 10;
			else if (winkel >= 10 && winkel < 15 )
				return 19;
			else if (winkel >= 15 && winkel < 20 )
				return 28;
			else if (winkel >= 20 && winkel < 25 )
				return 37;
			else if (winkel >= 25 && winkel < 35 )
				return 46;
			else if (winkel >= 35 && winkel < 50 )
				return 55;
			else if (winkel >= 50 && winkel < 70 )
				return 66;
			else if (winkel >= 70 && winkel < 90 )
				return 75;
			else return 0;
		}
		//Winkel zwischen 0 und 90
		else
		{
			if (winkel >= 0 && winkel <= 5 )
				return 0;
			else if (winkel >= -5 && winkel < 10 )
				return -10;
			else if (winkel >= -10 && winkel < 15 )
				return -19;
			else if (winkel >= -15 && winkel < 20 )
				return -28;
			else if (winkel >= -20 && winkel < 25 )
				return -37;
			else if (winkel >= -25 && winkel < 35 )
				return -46;
			else if (winkel >= -35 && winkel < 50 )
				return -55;
			else if (winkel >= -50 && winkel < 70 )
				return -66;
			else if (winkel >= -70 && winkel < 90 )
				return -75;
			else return 0;
	 	}
	}





	/** Methode catchArea
	  * berprft, ob der Tormann den Ball "catchen" kann
	  * @author sg
	  * @returns true/false
      * @see spielzug
	  */
	private boolean catchArea()
	{
		double laenge = 20;
		double breite = 10;
		if ( ballDistance <= (laenge) && penaltyArea() ) return true;
		else return false;
	}

	/** Wenn der Ball im Strafraum ist, liefert die Methode true zurck
	 * @author fg
	 * return true wenn Ball im Strafraum, ansonsten false
	 */
	private boolean penaltyArea()
	{
		int x = BallPosX;
		int y = BallPosY;
	  if ( (x >= -540) && (x <= -380) && (y >= -200) && (y <=  200) ) return true;
	  return false;
	}

	private int getWinkel(XyObject start, XyObject ziel)
	{
	  int deltaX = ziel.getX() - start.getX();
	  int deltaY = ziel.getY() - start.getY();
	  double entfernung = Math.sqrt((deltaX * deltaX) + (deltaY * deltaY));
	  if (entfernung== 0)  // start == ziel
	  {
	    return 0;
	  }
	  int dir = (arccos( (Math.abs(deltaY) / entfernung)));
    if (deltaY < 0)
    {
      if (deltaX > 0)
      {
        dir = 90 - dir;
	    }
	    else
	    {
	      dir = 90 + dir;
	    }
    }
    else //deltaY >= 0
    {
    	if (deltaX > 0)
    {
	     dir = 270 + dir;
     }
     else
     {
       dir = 270 - dir;
     }
    }
	  return dir;
	}
			/** Flo's Keeper, Spitzname "Blindfisch";)

				XyObject schnittPos;
	    		//Dann bist Du der TW
	      		this.ballDistance = ballDistance();
	        	Torwart torwart = (Torwart)play;
	      		if (BallPosX == 4444)
	      		{
	      			if(SelfPosY >= 0)
	        		{
	        			//nach rechts drehen
	          			torwart.turn(45);
	        		}
	        		else torwart.turn(-45);
	      		}
	      		//Spieler sieht den Ball
	      		else
	      		{
	    		    	if (aktOV.getSeeBall())
		    		 	  {
		    				  //Brlle die aktuelle Pos des Balls rum..
		    				  play.shout(BallPosXYZ, 12, new XyObject(0,0));
		    		 	  }
	              if (catchArea())
	            	{
	             	  torwart.catchBall(aktOV.getBallWinkel());
	           		 }
	           		 else if (MyArea(1))
	           		 {
	           		   torwart.moveTo(aktOV.getBallPos(), 100);
	           		 }
	            	 else if (BallPosX <= -460) // Panik :)
	             	 {
	                	schnittPos = schnitt(aktOV.getBallPos(), -520);
	                	if (schnittPos  != null)
	                	{
	                	  if (schnittPos.getY() <= 72 && schnittPos.getY() >=-72)
	                	  {
	                 			torwart.moveTo(schnittPos, 100);
	             			  }
	             			  else
	             			  {
	             			    if (BallPosY >=72)
	             			      torwart.moveTo(new XyObject(-520, 72),100);
	             			    else if (BallPosY <=-72)
	             			      torwart.moveTo(new XyObject(-520, -72),100);
	             			    else
	             			      torwart.moveTo(new XyObject(-520, BallPosY),100);
	             			  }
	                 	}
	                 	else //Ball schneidet nicht die -520er Linie
	                 	{
	                 	  XyzObject torWinkel = new XyzObject(aktOV.getBallPos().getX(),
	                 	                                      aktOV.getBallPos().getY(),
	                 	                                      -525 - aktOV.getBallPos().getX(),
	                 	                                      0 - aktOV.getBallPos().getY());
	                  	schnittPos = schnitt(torWinkel, -520);
	                  	if (schnittPos != null)
	                  	{
	                  	  if (schnittPos.getY() <= 72 && schnittPos.getY() >=-72)
	                  	  {
	                 			  torwart.moveTo(schnittPos, 100);
	               			  }
	               			  else
	               			  {
	                        if (BallPosY >=72)
	               			      torwart.moveTo(new XyObject(-520, 72),100);
	               			    else if (BallPosY <=-72)
	               			      torwart.moveTo(new XyObject(-520, -72),100);
	               			    else
	             	  		      torwart.moveTo(new XyObject(-520, BallPosY),100);
	             		  	  }
	                   	}
	                  }
	             	  }
	             		else
	                {
	                	schnittPos = schnitt(aktOV.getBallPos(), -490);
	                	if (schnittPos  != null)
	                	{
	                	  if (schnittPos.getY() <= 100 && schnittPos.getY() >=-100)
	                	  {
	                 			torwart.moveTo(schnittPos, 100);
	             			  }
	             			  else
	             			  {
	             			    if (BallPosY >=100)
	             			      torwart.moveTo(new XyObject(-490, 100),100);
	             			    else if (BallPosY <=-100)
	             			      torwart.moveTo(new XyObject(-490, -100),100);
	             			    else
	           	  		      torwart.moveTo(new XyObject(-490, BallPosY),100);
	           		  	  }
	                 	}
	                	else // schneidet nicht -490, also tormitte
	                	{
	                 	  XyzObject torWinkel = new XyzObject(aktOV.getBallPos().getX(),
	                 	                                      aktOV.getBallPos().getY(),
	                 	                                      (-525 - aktOV.getBallPos().getX()),
	                 	                                      (0 - aktOV.getBallPos().getY()));
	                  	schnittPos = schnitt(torWinkel, -490);
	                  	if (schnittPos != null)
	                  	{
	                  	  if (schnittPos.getY() <= 100 && schnittPos.getY() >=-100)
	                  	  {
	                 			  torwart.moveTo(schnittPos, 100);
	               			  }
	               			  else
	               			  {
			                    if (BallPosY >=100)
	               			      torwart.moveTo(new XyObject(-490, 100),100);
	               			    else if (BallPosY <=-100)
	               			      torwart.moveTo(new XyObject(-490, -100),100);
	               			    else
	             	  		      torwart.moveTo(new XyObject(-490, BallPosY),100);
	             		  	  }
	                   	}
	                	}
              	}}
				*/
}

/*
 * $Log: Taktik.java,v $
 * Revision 1.114  2002/07/14 21:36:04  sg
 * Jetzt Final Version (Der Abwurf ist jetzt so wie ich mir das vorstelle *g*)
 *
 * Revision 1.113  2002/07/14 20:44:45  sg
 * Final Version
 *
 * Revision 1.112  2002/07/14 16:26:53  sg
 * TW implementiert.. Er ist zwar noch immer nicht der Held, wei aber was man unter Stellungsspiel versteht ;D
 *
 * Revision 1.111  2002/07/14 12:07:07  sg
 * Testausgaben beseitigt.. Jetzt haben wir noch eine grosse Schwachstelle: Flo's Keeper
 *
 * Revision 1.110  2002/07/14 10:34:28  sg
 * Testausgaben, kleinigkeiten beseitigt
 *
 * Revision 1.109  2002/07/11 16:56:37  sg
 * System.out.println's eingebaut
 *
 * Revision 1.108  2002/07/08 06:59:00  sg
 * Testausgaben entfernt - und der Torwart macht seinen Abschlag entwas seitlicher..
 *
 * Revision 1.107  2002/07/08 06:46:26  sg
 * Probs in den Playmodes behoben
 *
 * Revision 1.106  2002/07/08 06:35:39  fg
 * *** empty log message ***
 *
 * Revision 1.105  2002/07/08 06:07:21  sg
 * Fehler in den playmodes() behoben (nach vernderter X-Koord wurde kein neues XyObject angelegt..)
 *
 * Revision 1.104  2002/07/08 05:04:25  fg
 * Torwart drinne
 *
 * Revision 1.103  2002/07/08 04:32:18  sg
 * Spieler richten sich auf Ball aus
 *
 * Revision 1.102  2002/07/08 04:16:13  sg
 * *** empty log message ***
 *
 * Revision 1.101  2002/07/08 03:58:26  sg
 * findPos() verbessert?
 *
 * Revision 1.100  2002/07/08 02:57:40  sg
 * javadocs eingefgt
 *
 * Revision 1.99  2002/07/08 02:40:17  sg
 * Kommentare eingefgt
 *
 * Revision 1.98  2002/07/08 00:25:14  sg
 * *** empty log message ***
 *
 * Revision 1.97  2002/07/08 00:15:12  fg
 * *** empty log message ***
 *
 * Revision 1.96  2002/07/08 00:14:11  sg
 * schnitt bei Abwehr eingebaut
 *
 * Revision 1.95  2002/07/07 23:18:43  fg
 * Fehler in schnitt korrigiert
 *
 * Revision 1.94  2002/07/07 23:17:12  fg
 * - FutureBall und schnitt korrigiert
 *
 * Revision 1.93  2002/07/07 23:14:38  sg
 * *** empty log message ***
 *
 * Revision 1.92  2002/07/07 22:43:54  sg
 * *** empty log message ***
 *
 * Revision 1.91  2002/07/07 22:14:10  sg
 * nahezu alles berarbeitet ;)
 *
 * Revision 1.90  2002/07/07 17:56:38  sg
 * Test fr moveBlind
 *
 * Revision 1.89  2002/07/07 17:26:17  sg
 * Probleme der Nummer 6 behoben..
 *
 * Revision 1.88  2002/07/07 17:22:55  sg
 * findPos() modifiziert
 *
 * Revision 1.87  2002/07/07 17:02:53  sg
 * myArea() gendert
 *
 * Revision 1.86  2002/07/07 16:27:33  sg
 * StaminaProb behoben??
 *
 * Revision 1.85  2002/07/07 16:01:52  sg
 * findPos() weiterverbessert
 *
 * Revision 1.84  2002/07/07 03:39:51  sg
 * *** empty log message ***
 *
 * Revision 1.83  2002/07/07 03:05:32  sg
 * Abseits teilweise implementiert
 *
 * Revision 1.82  2002/07/07 02:57:02  fg
 * *** empty log message ***
 *
 * Revision 1.81  2002/07/06 22:59:54  fg
 * - getFutureBall eingefgt
 * - sin und cos Array wie arccos eingefgt.
 *
 * Revision 1.80  2002/07/06 22:29:27  sg
 * Testausgabe aus
 *
 * Revision 1.79  2002/07/06 21:51:47  sg
 * Playmodes korregiert
 *
 * Revision 1.78  2002/07/06 21:28:35  fg
 * Arccos Methoden kommentiert
 *
 * Revision 1.77  2002/07/06 21:27:35  sg
 * einiges berarbeitet
 *
 * Revision 1.76  2002/07/06 21:11:42  fg
 * Effiziente Arccos eingebaut
 *
 * Revision 1.75  2002/07/06 20:01:42  sg
 * weitere Auftstellung eingefhrt
 *
 * Revision 1.74  2002/07/06 17:46:23  sg
 * playmodes kleingeschrieben
 *
 * Revision 1.73  2002/07/06 17:22:05  sg
 * neue Pass()
 *
 * Revision 1.72  2002/07/06 17:20:16  pg
 * anstoss linksrechtsfehler korrigiert
 *
 * Revision 1.71  2002/07/06 16:34:37  sg
 * myJob() hatte Fehler
 *
 * Revision 1.70  2002/07/06 16:02:44  sg
 * Torschuss wieder entfernt
 *
 * Revision 1.69  2002/07/06 15:32:11  sg
 * Torschuss() verbessert??
 *
 * Revision 1.68  2002/07/06 14:32:04  sg
 * neuste Taktik
 *
 * Revision 1.67  2002/07/06 02:50:55  fg
 * Torwart weitergemacht
 *
 * Revision 1.66  2002/07/06 02:21:13  sg
 * findPos fertiggestellt
 *
 * Revision 1.65  2002/07/06 00:42:18  fg
 * *** empty log message ***
 *
 * Revision 1.64  2002/07/06 00:37:24  sg
 * Fehler in findPos behoben
 *
 * Revision 1.63  2002/07/06 00:22:43  sg
 * Abwehr etwas offensiver eingestellt ;)
 *
 * Revision 1.62  2002/07/05 23:58:05  fg
 * *** empty log message ***
 *
 * Revision 1.61  2002/07/05 23:51:05  sg
 * findpos modifiziert
 *
 * Revision 1.60  2002/07/05 23:35:20  fg
 * Conflict raus
 *
 * Revision 1.59  2002/07/05 23:34:33  sg
 * Mittelfeldspieler etwas zurckbeordert..
 *
 * Revision 1.58  2002/07/05 23:11:09  sg
 * Fehler behoben
 *
 * Revision 1.57  2002/07/05 22:51:24  fg
 * Torwart angefangen zu implementieren
 *
 * Revision 1.56  2002/07/05 22:24:03  sg
 * findPos() implementiert
 *
 * Revision 1.55  2002/07/05 19:56:35  sg
 * Testtaktik
 *
 * Revision 1.54  2002/07/05 19:23:09  sg
 * findPos() teilweise drin
 *
 * Revision 1.53  2002/07/05 17:27:31  sg
 * neue Version
 *
 * Revision 1.52  2002/07/05 17:15:03  sg
 * neuste Taktik ;)
 *
 * Revision 1.51  2002/07/03 17:38:50  tm
 * mit dem Torwart begonnen
 *
 * Revision 1.50  2002/07/03 17:18:50  tm
 * myArea fr den Torwart eingefgt
 *
 * Revision 1.49  2002/07/03 17:04:56  tm
 * cathArea implementiert und JavaDoc ergnzt
 *
 * Revision 1.48  2002/07/03 10:19:18  fg
 * *** empty log message ***
 *
 * Revision 1.47  2002/07/03 06:49:52  sg
 * takePos() implementiert.. Leider keine Zeit mehr gehabt zum Testen..
 *
 * Revision 1.46  2002/07/02 22:04:57  fg
 * Dummen Tippfehler beseitigt :)
 *
 * Revision 1.45  2002/07/02 21:51:56  fg
 * Fehler (hoffentlich) ausgemerzt, der dafr sorgen konnte das jeder Thread evtl. abgeschossen werden kann.
 *
 * Revision 1.44  2002/07/02 18:01:29  sg
 * Die ganzen Flags rausgenommen, da sie irgentwelche Fehler erzeugt haben. findPos berarbeitet, takePos schreib ich rein, wenn moveTo endlich geht.. Und es wre nett, wenn die Abwehrspieler nichtmehr auf das eigene Tor schiessen wrden ;D
 *
 * Revision 1.43  2002/06/30 18:27:06  sg
 * Fehler in myArea() gefunden und behoben.. (Anm.: Wenn man eine Strecke in 8 Teile teilt, hat man 9 und nicht 8 Pkte *g*)
 *
 * Revision 1.42  2002/06/30 16:59:38  sg
 * Neuste Version der Taktik - einige Sachen wurden gendert.
 * @Tobi
 * Die Methode MyArea() scheint einen Fehler zu haben.. Entweder stimmt was mit der Ermittlung des Index nicht oder oder es liegt wirklich daran, das die BallPos noch nicht stimmt. Aber schau es Dir bitte mal genau an und versuch den Fehler zu finden.. FindPos sollten wir morgen oder heute Abend noch schreiben.. Leider ist eine vom Gegner abh. torschuss oder pass Methode nicht mglich, da wir den Gegner nicht sehen knnen und ich glaube mittlerweile nichtmehrdran, dass das sich demnchst ndern wird..
 *
 * Revision 1.41  2002/06/26 11:58:33  fg
 * *** empty log message ***
 *
 * Revision 1.40  2002/06/26 08:38:49  sg
 * Hab damit fast ein Tor erzielt.. Es besteht Hoffnung :))
 *
 * Revision 1.39  2002/06/26 06:43:07  sg
 * Da jetzt angeblich die Spieler doch was machen, fge ich die komplexere Pass() wieder ein.. Vielleicht schaffen wir ja so schon den SimpleClient *g*
 *
 * Revision 1.38  2002/06/25 21:38:29  tm
 * kleinere fehler behoben
 *
 * Revision 1.37  2002/06/25 20:16:51  sg
 * Methode Spielzug() stark zusammengefasst und die ellenlange schlechte Methode Pass() entnommen und durch eine kurze, aber ebenso simple ersetzt.
 *
 * Revision 1.36  2002/06/21 16:44:29  sg
 * Fehler behoben
 *
 * Revision 1.35  2002/06/21 09:43:33  sg
 * Die Methode torschuss() in die endgltige Fassung gebracht. Es fehlt nur noch die getMethode die uns die Torbreite bermittelt (gibts noch nicht)
 *
 * Revision 1.34  2002/06/20 18:14:06  sg
 * Verbesserte Version von torschuss() implementiert. Ebenso die Hilfsmethode winkelbrechnen()
 *
 * Revision 1.33  2002/06/20 14:27:23  tm
 * JavaDoc eingefgt
 *
 * Revision 1.32  2002/06/20 13:27:04  sg
 * Wieder ein paar Fehler weniger..
 *
 * Revision 1.31  2002/06/20 12:46:54  sg
 * Ein greres Update der Taktik:
 * 1.) Die Anordnung entspricht jetzt dem Aufruf der einzelnen Methoden. Dadurch ist es leichter nachzuvollziehen, wie ein Spieller seine Entscheidung trifft.
 * 2.) Bisher hat jeden Methode sich die Daten fr die eingene Pos (SelfPos) und die des Balls (BallPosXY) selbst beschafft. Jetzt werden sie nur einmal beschafft und abgespeichert.
 * 3.) Kleinere Fehler behoben
 * 4.) Die If / Else Schleifen wurden eingerckt
 * 5.) Ein TODO InfoTool wurde eingefhrt (Ganz am Ende)
 *
 * Revision 1.30  2002/06/19 20:04:40  tm
 * NullPointerException beseitigt
 *
 * Revision 1.29  2002/06/19 16:24:35  tm
 * myJob() implementiert
 *
 * Revision 1.28  2002/06/19 12:05:08  pg
 * 0 byte
 *
 * Revision 1.25  2002/06/18 19:49:50  tm
 * findPos() implementiert
 *
 * Revision 1.24  2002/06/18 18:37:38  sg
 * Viele Fehler behoben.. Allerdings macht die Methode moveTo einen Fehler, den ich net rausbekomme ;((
 *
 * Revision 1.23  2002/06/18 10:34:43  sg
 * Methode Torschuss() implementiert. Ein paar Doku's eingefgt.
 *
 * Revision 1.22  2002/06/18 10:17:49  sg
 * eine einfache Version von pass() implementiert. Den PseudoCode der Strmer bersetzt, die Methode Torschuss doch wieder aufgenommen, Kleinere Fehler gefixt..
 *
 * Revision 1.21  2002/06/17 21:47:29  sg
 * Ein paar Methoden zusammengefasst und move in moveTo gendert
 *
 * Revision 1.20  2002/06/17 20:46:03  tm
 * NullPointerException beseitigt
 *
 * Revision 1.19  2002/06/17 20:09:33  tm
 * Fehler behoben (Lnge des Feldes)
 *
 * Revision 1.18  2002/06/17 19:54:52  fg
 * - Thread.yield() wurde durch Thread.sleep(5) mit Interrupt-handling ersetzt.
 *
 * Revision 1.17  2002/06/17 19:24:06  tm
 * Distance() in ballDistance() umbenannt und xyDistance() eingefgt
 *
 * Revision 1.16  2002/06/17 16:28:54  sg
 * Die Methode run() wurde in start() umbenannt, da es so einheitlich ist. Auerdem wurde initFlags() aus der unendlichen Schleife genommen, da eine Initialisierung reicht ;)
 *
 * Revision 1.15  2002/06/17 15:47:59  sg
 * PlayArea() Implementiert. GoalArea() rausgeworfen (berflssig, MyArea() deckt alles ab).
 *
 * Revision 1.14  2002/06/16 16:55:58  tm
 * MyArea() implementiert
 *
 * Revision 1.13  2002/06/16 12:27:00  tm
 * methode getIndex() eingefgt um eine (x,y)-Koordinate dem nhesten flag zuzuordnen
 *
 * Revision 1.12  2002/06/16 09:57:53  tm
 * das array flags angelegt und die methode initFlags(), die das array mit den (x,y)-Koordinaten belegt, hinzugefgt
 *
 * Revision 1.11  2002/06/16 09:41:41  sg
 * So der Rohbau steht jetzt. Strmer und Torwart sind fast fertig, Abwehr und Mittelfeld ist drin. Jetzt muss noch das "Drahtgitter" drber und die Methoden geschrieben werden, die ein Spieler in abh. des Weltbildes aufruft.
 *
 * Revision 1.10  2002/06/15 14:54:27  sg
 * Der Pseudo-Code weitestgehend in eine dem Compiler verstndliche Sprache gebracht. Fehlende Methoden wurden hinzugefgt, mssen aber noch mit "Leben" gefllt werden. Lt sich jedoch fehlerfrei compilieren.
 * @Tobi
 * Die 4 neuen Methoden mssen wir dann in Angriff nehmen!
 *
 * Revision 1.9  2002/06/15 11:33:16  sg
 * Methodenrumpf steht, Taktiken in leider noch in Pseudoform, werden noch bersetzt und weiterverfeinert.
 * @Tobi
 * versuch mal meinen Grobentwurf zu verstehen - ich werde ihn heute noch verfeinern und teilweise bersetzten.Wre gut wenn, Du die Methode pass() hinbekommen knntest :)
 *
 * Revision 1.8  2002/06/12 09:49:42  pg
 * - "4444"-konvention angepasst
 *
 * Revision 1.7  2002/06/12 08:24:23  sg
 * getSelfPos war fehlerhaft, wurde korregiert. Mir scheint es als fehlt auch das Abfangen im OverviewObjekt fr den Fall das der Ball nicht sichtbar ist.. Habe es als 0 definiert, da die Pos des Balls vor der bergabe der aktuellen Parameter auf 0 gesetzt wird. Hoffe das es so funzzt ;)
 *
 * Revision 1.6  2002/06/11 20:40:20  sg
 * Die Taktikbib wurde deaktiviert. Bis auf die Tatsache das import Player / OverviewObject nicht funktioniert, gibts keine Fehler mehr
 *
 * Revision 1.5  2002/06/11 18:58:25  tm
 * kleinere Fehler korrigiert
 *
 * Revision 1.4  2002/06/11 14:39:19  sg
 * Kommentare noch eingefgt. Btw: Wer hat in Rev 1.2 die importbefehle eingefgt?? Diese funktionieren leider nicht!
 *
 * Revision 1.2  2002/06/07 19:11:34  fg
 * import Player und import OverviewObject hinzugefgt, findet das sonst nicht (da nicht eigenes package)
 *
 * Revision 1.1.1.1  2002/06/05 10:38:57  pg
 * intital version
 *
 *
 */
